<?php
/**
	 * Init the creation of algorithms GUI form
	 *
	 *@param string contains the Id of the algorithm
 */
function Algorithms($id){
	try{
		$xres = new xajaxResponse();
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$table_name = $_SESSION["table_name"];
		if($table_name == '' && $id != 26){
			throw(new Exception("Not exists any table selected."));
		}elseif (substr($table_name,strlen($table_name)-3,3) == "_dd"){
			throw(new Exception("This table is only for information purpose"));
		}
		require_once("../../class/msg/algorithmForm.php");
		//algorithm application
		$xres->script("CleanMatch = 'clean';");
		switch ($id){		
			case 1:
				//discretize				
				$conten = "380,215";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE Type = 'double' or Type = 'int(11)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$desc = "<B>Attribute:</B> List of number type attributes";
				$alg_form->addCombo("column","Atribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$desc = "<B>Bins:</B> A number greater than zero for the bins";
				$alg_form->addNumberField("bins","Bins",0,"/^\d+$/","Invalid Number, only digits","false","false","","",$desc);
				$msg = "The discretize procedure only applies on numeric attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Discretize</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";				
				$xres->script($alg_form->getForm($func));
				$desc = "Transfer continuous data into discrete counterparts. This filter is only applied on numeric attributes";
				$ex = "Entering number 3 to the entry field would divide observations 3, 5, 6, 9 and 10 to bins 3-5.5, 5.5-9.5 and 9.5-10";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;				
			case 2:
				//null clean
				$conten = "400,210";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE Type = 'double' OR  Type = 'int(11)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$combo_func = "['__supr__','supr'],";
				$combo_func .= "['__avg__','average'],";
				$combo_func .= "['__rnd__','random_mid'],";
				$combo_func .= "['__rnd2__','random_full'],";
				$combo_func .= "['__mode__','mode'],";
				$combo_func .= "['__cero__','zero'],";
				$combo_func .= "['__cero__','class_rule'],";
				$combo_func .= "['__max__','max'],";
				$combo_func .= "['__min__','min'],";
				$combo_func .= "['__var__','variance'],";
				$combo_func .= "['__sum__','sum'],";

				$combo_func = substr($combo_func,0, strlen($combo_func)-1);
				$desc = "<B>Column:</B> List of number type attributes";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$desc = "<B>Replace With:</B> List the centralization measures<br>";
				$alg_form->addCombo("func","Replace With","'id', 'func_name'",$combo_func,"Select a Function...","func_name",$desc);								
				$msg = "The number null clean procedure only applies on numeric attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Number Null Clean</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "
				Fill the null values with the centralization measure selected. these measures are:<br>
				-<b>supr</b> -><br>
				-<b>average</b> ->This filter takes charge of filling all the null data of a certain attribute with the value average of all the values that contains that attribute.<br><br>
				-<b>random_mid</b> -> It is a very useful filter because it provides centralized random values keeping in mind the size of the sample, achieving all null data so becomes a data useful and outstanding chord to the context of the average of the data. <br><br>
				-<b>random_full</b> -> It is a random value of the whole populational sample, useful to maintain all the values inside the biggest and smaller range value of the whole sample.<br><br>
				-<b>mode</b> -> It is a filter that takes charge of filling the null data with the values of more frequency inside the populational sample, this way these new values will help to maintain this sample data sufficiently centralized.<br><br>
				-<b>zero</b> -> It replaces all the null data for the value zero (0). it is a very useful filter for samples in which the existence of a value is needed that it is not the NULL.<br><br>
				-<b>class_rule</b> -> The class rule is the half value between the value of smaller magnitude and the value of biggest magnitude. It is a very useful filter because it provides a fact centralized chord to the existent data in the attribute and relative to the size of the same ones<br><br>
				-<b>max</b> -> This filter is useful to fill all the null fields with the biggest value that is inside the whole populational sample of the attribute.<br><br>
				-<b>min</b> -> This filter is useful to fill all the null fields with the smallest value that is inside the whole populational sample of the attribute.<br><br>
				-<b>variance</b> -> It is a filter which is applied to fill the null fields with an average of the distance that is among the different present data in a sample with the purpose of that those new data are in agreement with all the evaluated values and don't be omitted for a possible analysis.<br><br>
				-<b>sum</b> -> It is an useful filter, to fill all the null data with the result of the sum of the different existent values in the attribute.<br><br>
				";
				$ex = "
				-<b>supr</b> -><br>
				-<b>average</b> ->The average of values: 8, 5 y -1 is equal to 4.<br><br>
				-<b>random_mid</b> -> RANDOM_MID {3,1,5,7,12,8,4}<br>PROM = 5,714285714.<br>DESV_EST = 3,638419332.<br>THEN RANDOM_MID {3,1,5,7,12,8,4} = RANDOM([PROM – DESV_EST, PROM + DESV_EST]) = 6.5; 6.9; 4.25; etc;<br><br>
				-<b>random_full</b> -> RANDOM_FULL{3,1,5,7,12,8,4}<br> THEN RANDOM_FULL {3,1,5,7,12,8,4} = RANDOM ({3,1,5,7,12,8,4}) = 1; 3; 12; 9; 6 etc.<br><br>
				-<b>mode</b> -> Renault = 120, Chevrolet = 100, Mazda = 60, BMW = 1, Null Data = 12<br> THEN Null Data will be replaced with Reanult because it is that of more frequency.<br><br>
				-<b>zero</b> -> Replace all with zero (0).<br><br>
				-<b>class_rule</b> -> CLASS_RULE{3,1,5,7,12,8,4}=(1+12)/2=6.5<br><br>
				-<b>max</b> -> MAX {3, 1, 5, 7, 12, 8, 4} = 12<br><br>
				-<b>min</b> -> MIN {3, 1, 5, 7, 12, 8, 4} = 1<br><br>
				-<b>variance</b> -> <br><br>
				-<b>sum</b> -> only sum all the sample values. SUM{4,6,8,9,3} = 30 <br><br>						
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
				
			case 3:	
			//charReplace	
				$conten = "380,400";
				$mov = "220,80";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name ." where type = 'varchar(255)'";
				$name = "column";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Available Attributes';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>Multiselect:</b> List of attributes in which it will be look for a character or string</B>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);				
				$desc = "<B>OldChar:</B> Type the char or string to replace";
				$alg_form->addTextField("oldchar","OldChar","/^.+$/","Please type a valid string","false","","","","",$desc,30);
				$desc = "<B>NewChar:</B> Type the new char or string<br>";
				$alg_form->addTextField("newchar","NewChar","/^.+$/","Please type a valid string","false","","","","",$desc,30);				
				$msg = "The CharReplace procedure only applies on string attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Char Replace</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "Replace char or string in the selected fields.<br><br>";
				$ex = "
				If inside two attributes (field1 and field2) in one or more rows is the character ¥ and we want to replace it by Ñ then:<br><br>
				<b>multiselect</b>: Pass these two attributes to the Selected Attributes list.<br>
				<b>OldChar</b>: ¥<br>
				<b>NewChar</b>: Ñ<br>
				Apply the filter.<br><br>
				<center><img src='../../icons/charreplacesample.JPG'></center><br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			case 4:
				//Changeattributetype
				$conten = "380,195";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');				
				$query = "SHOW COLUMNS FROM $table_name";
				$res = $con->query($query);
				$FieldId = 0;
				while($row = $con->fetch($res)){
					if($FieldId != 0){
						$combo_columns .= "['__" . $row['Field']  . "__','" . $row['Field'] . " " . $row['Type'] ."'],";
					}else{
						$FieldId = 1;
					}
				}
				$combo_columns = substr($combo_columns,0, strlen($combo_columns)-1);
				$desc = "<B>Combo Box:</B> List of attributes<br>";
				$alg_form->addCombo("column","Base Attribute","'id','column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$alg_form->addCombo("column2","New Type","'id','column_name'","[]","Select an Attribute...","column_name",$desc);
				$msg = "</center>Change Attribute Type</center><br>&nbsp;";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Change Attribute Type</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',2,'$table_name')";
				$alg_form->ComboEvent('column','column2',"'id','column_name'");
				$xres->script($alg_form->getForm($func));
				$desc = "
				Change Attribute Type<br>
				Cases:<br>
				&nbsp;&nbsp; String to Double.<br>
				&nbsp;&nbsp; String to Int.<br>
				&nbsp;&nbsp; String to Date.<br>
				&nbsp;&nbsp; String to DateTime.<br>
				&nbsp;&nbsp; String to Time.<br>
				&nbsp;&nbsp; Double to String.<br>
				&nbsp;&nbsp; Int to String.<br>
				&nbsp;&nbsp; Date   to String.<br>
				&nbsp;&nbsp; Date Time to String.<br>
				&nbsp;&nbsp; Time to String.<br><br>
				";
				$ex = "
				If an attribute is in String type and all the data inside these attribute has numeric values is better for clean and transform procces to change the type to Double(Number) <br><br>
				<center><img src='../../icons/changeatt_type.JPG'></center><br>
				<b>PLEASE NOTE:</b><br>If some of those values don't fulfill the new data type then a new temporary data table will be generated, where those values will be able to be eliminated or modified (one to one or all together)<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
				
			case 5:
				//normalize
				$conten = "370,193";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');

				$filter = $table_name . " WHERE Type = 'double' OR Type = 'int(11)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$desc = "<B>Attribute:</B> list of number type attributes<br>";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$msg = "The Normalize procedure only applies on numeric attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Normalize</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "Normalize is transform a random variable that has some distribution in a new random variable with normal or approximately normal distribution.<br><br>";
				$ex = "The following is an example of a normalized data sample:<br><br>
				<center><img src='../../icons/normalized.JPG'></center><br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;

			case 6:
				//table details
				$conten = "380,340";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();				
				$fromData = $encdec->jComboSelect($table_name,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Available Attributes';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of the data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);

				$desc = "<B>Attribute:</B> list of number fields";
				$msg = "Table Details (Selection Filter)<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Table Details</B>",$msg));
				$desc = "This filter generates a temporary data table based on the selected attributes and it adds an attribute in which the quantity of occurrences is shown of oneself row in the data table<br><br>";
				$ex = "If an attribute selected has 2 equal ocurrences then the new attribute should show the number 2.<br><br><br><br><br><br><br><br><br>";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");			
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));	
				break;
				
			case 7:
				//delete attributes
				$conten = "380,340";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();				
				$fromData = $encdec->jComboSelect($table_name,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Available Attributes';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "The Delete Attributes procedure applys to all attribute types<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Delete Attributes</B>",$msg));
				$desc = "Delete selected attribute(s)";
				$ex = "
				This filter is used when it is necessary to reduce the size of the data table, in such a way that the unnecessary attributes are eliminated<br><br>
				<center><img src='../../icons/deleteatt1.JPG'></center><br><br>
				Unnecessary Attribute : <b>field1</b><br><br>
				<center><img src='../../icons/deleteatt2.JPG'></center><br><br>
				Result:<br><br>
				<center><img src='../../icons/deleteatt3.JPG'></center><br>				
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");			
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 8:
				//duplicates
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();				
				$fromData = $encdec->jComboSelect($table_name,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Duplicates Search (Selection Filter)<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Duplicates Search</B>",$msg));
				$desc = "
				This is a filter that search for all the exactly same rows keeping in mind the attributes that are specified for the search, that is to say, it search the real copies inside a data table<br>
				";
				$ex = "When using this filter a temporary data table is generated with the rows that have duplicates.";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));				
				break;
			
			case 9:
				//levenshtein
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name ." WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Levenshtein Procedure (Selection Filter)<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Levenshtein Search</B>",$msg));
				$desc = "Levenshtein Search<br>This filter search all the possible similarities in two strings based on distances, that is to say, it search and shows all the words than could be appear equals.<br><br>
				Those distances means insert, modification or elimination of characters inside any of two strings.<br><br>
				While smaller it is the distance, more possibility it exists that the strings are the same ones.<br><br>
				For further precision this distance should be smaller or equal to 2.<br><br>";
				$ex = "
				- The Levenshtein Distance between kitten and sitting is 3<br>
				&nbsp;&nbsp;&nbsp; (Replace k for s, Replace e for i and Insert g) Total : 3 Transformation steps<br><br>				
				- The Levenshtein Distance between Ardila and Ardiya is 1<br>
				&nbsp;&nbsp;&nbsp; (Replace l for y) Total : 1 Transformation step<br><br>
				According to the above this filter will generate a temporary data table with the two rows Ardila and Ardiya respectively.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 10:
				//rule editor
				$conten = "550,380";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$desc = "<b>Text Area</b>: All the conditions and assignments to be considered.";
				$alg_form->addEditor("editor","Expert Rule Editor","510","250",$desc);
				$msg = "";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Expert Rule Editor</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_ruleEditor('".$id."','".$table_name."')";
				$xres->script($alg_form->getFormRule($func,'editor'));
				$desc = "In this filter the analyst can introduce rules to modify the content of a field. The basic form of this sentence is the following one:<br><br>If (Condition) {<br>Sentence_1;<br>Sentence_2;<br>}<br><br>";
				$ex = "<br><center><img src='../../icons/rule.JPG'></center><br>For more information please refer to <B>USER MANUAL<B>.";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 11:
				//nonprintable
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();		
				$filter = $table_name . " WHERE Type = 'varchar(255)'";		
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "NonPrintableCharacter Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>NonPrintableCharacter</B>",$msg));
				$desc = "
				Non Printable Character Search.<br>
				This filter allows in the first place, to carry out a detailed search of those characters that are not considered printable and in second place to make a treatment on this characters (replace, eliminate) through a temporary data table who has the non printable characters and the user suggestions to replace those characters.<br>";
				$ex = "Replace all the characters like ¥ or �? or └ or ┴ by N";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));				
				break;
			
			case 12:
				//upper case
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attirbutes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "UpperCase Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>UpperCase Procedure</B>",$msg));
				$desc = "
				This filter allows to convert all the values inside one or more attributes to UPPER CASE, it could be called as an Standardization Filter.
				";
				$ex = "
				Convert jack to JACK <br>
				Convert luis to LUIS <br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 13:
				//lower case
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "LowerCase Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>LowerCase Procedure</B>",$msg));
				$desc = "
				This filter allows to convert all the values inside one or more attributes to LOWER CASE, it could be called as an Standardization Filter.
				";
				$ex = "
				Convert JACK to jack<br>
				Convert LUIS to luis<br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";				
				$xres->script($alg_form->getForm($func));
				break;
		
			case 14:
				//trim
				$conten = "440,325";
				$mov = "100,20";				
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "Trim Procedure only applys on string type attributes<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Trim Procedure</B>",$msg));
				$desc = "
				This filter allows to remove all the spaces at the beginning or at the end of a string<br>
				";
				$ex = "If a string is like this \" string one \"<br> Then after applying this filter, this stringe will be like this \"string one\"<br>";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 15:
				//MaxLength
				$conten = "370,220";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$desc = "<B>Attribute:</B> List of string type attributes";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$desc = "<B>Length:</B> A number greater than zero for the bins";
				$alg_form->addNumberField("length","Length",0,"/^\d+$/","Invalid Number, only digits","false","false","","",$desc);
				$msg = "Max Length procedure only applies on string type attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Max Length</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "This filter is used to search string with a size bigger than the specified one.<br>				
				";
				$ex = "Max length = 4 to (Juan, Kennedy, Carl).<br>
				The filter Shows (Kennedy) because Kennedy's length is bigger than 4.
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 16:
				//MinLength
				$conten = "370,220";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$desc = "<B>Attribute:</B> list of string type attribute";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$desc = "<B>Length:</B> a number greater than zero for the bins";
				$alg_form->addNumberField("length","Length",0,"/^\d+$/","Invalid Number, only digits","false","false","","",$desc);
				$msg = "Min Length procedure only applies on string type attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Min Length</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "This filter is used to search string with a size smaller than the specified one.<br>
				";
				$ex = "Min length = 5 to (Juan, Kennedy, Carl).<br>
				The filter Shows (Juan, Carl) because this words's length is smaller than 5.
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 17:
				//Truncate
				$conten = "400,240";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE Type = 'varchar(255)'";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				
				unset($truncate);
				$truncate = "['__Left__','Left'],['__Right__','Right']";
				
				$desc = "<B>Attribute:</B> list of string type attribute";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				
				$desc = "<B>Truncate by:</B> If it will be a left or right truncate.";
				$alg_form->addCombo("truncate","Truncate by","'id', 'column_name'",$truncate,"Select Truncate by...","column_name",$desc);
				
				$desc = "<B>Length:</B> A number greater than zero.<br>";
				$alg_form->addNumberField("length","Length",0,"/^\d+$/","Invalid Number, only digits","false","false","","",$desc);
				$msg = "Truncate String procedure only applies on string attributes <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Truncate String</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter is used to cut string characters from left or right side.<br>
				";
				$ex = "Truncate for right to 3 characters COLOMBIA -->  COL<BR>Truncate for left to 3 characters COLOMBIA -->  OMBIA";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
				
			case 18:
				//Column Clear
				$conten = "410,170";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');

				$filter = $table_name;
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				
				$desc = "<B>Attribute:</B> List of all attribute types inside the data table<br>";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				
				$msg = "Attribute Clear applys on all attribute types<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Attribute Clear</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter is used when it is necessary to clear an attribute who has too many missing values and it would be filled with some other standar values (using Expert Rule Editor).<br><br>
				";
				$ex = "
				Simply choose the attribute you want to clear and press Apply button.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;

			case 19:
				//Add column
				$conten = "410,195";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				
				$combo_columns = "['__varchar__','varchar(255)'],";
				$combo_columns .= "['__double__','double'],";
				$combo_columns .= "['__double__','int(11)'],";
				$combo_columns .= "['__date__','date'],";
				$combo_columns .= "['__dateTime__','dateTime'],";
				$combo_columns .= "['__time__','time']";
				
				$desc = "<B>Attribute Type:</B> thew type of the new attribute.";
				$alg_form->addCombo("type","Attribute Type","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$sql = "SHOW COLUMNS FROM $table_name;";
				$res = $con->query($sql);
				unset($column_names);
				while($row = $con->fetch($res)){
					$column_names .= $row['Field'] . "&&&";
				}
				$desc = "<B>Attribute Name:</B> The name of the new attribute.<br>";
				$regexText = "Invalid name";
				$alg_form->addTextField('name','Attribute Name',"/^[a-zA-Z]+[a-zA-Z0-9]*$/",$regexText,"false",$column_names,'This attribute already exists.','','',$desc,15);
				$msg = "Create a new Attribute <br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Add Attribute</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";				
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter is used when it is necessary to add an attribute which would be filled with some other standard values (using Expert Rule Editor).<br><br>
				";
				$ex = "
				Simply especify the new attribute type and the new name for these attribute.<br>
				The attribute type options are: varchar(255), double, date, dateTime, time.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));				
				break;
			
			case 20:
				//Soundex
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name ." WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Soundex Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Soundex Search</B>",$msg));
				$desc = "This filter generates a temporary data table based on Soundex Algorithm  with the possible coincidences between the values of a an determinate number of attributes.<br><br>
				<b>Soundex</b> Is a phonetic algorithm for indexing names by sound.<br>
				The goal is for names with the same pronunciation to be encoded to the same representation so that they can be matched despite minor differences in spelling.<br>
				The Soundex code for a name consists of a letter followed by three numbers: the letter is the first letter of the name, and the numbers encode the remaining consonants. Similar sounding consonants share the same number so, for example, the labial B, F, P and V are all encoded as 1. Vowels can affect the coding, but are never coded directly unless they appear at the start of the name.
				The exact algorithm is as follows:<br><br>
				1. Retain the first letter of the string.<br>
   				2. Remove all occurrences of the following letters, unless it is the first letter: a, e, h, i, o, u, w, y.<br>
   				3. Assign numbers to the remaining letters (after the first) as follows:<br><br>
   				&nbsp;&nbsp;&nbsp; b, f, p, v = 1<br>
   				&nbsp;&nbsp;&nbsp; c, g, j, k, q, s, x, z = 2<br>
   				&nbsp;&nbsp;&nbsp; d, t = 3<br>
   				&nbsp;&nbsp;&nbsp; l = 4<br>
   				&nbsp;&nbsp;&nbsp; m, n = 5<br>
   				&nbsp;&nbsp;&nbsp; r = 6<br><br>
   				4. If two or more letters with the same number were adjacent in the original name (before step 1), or adjacent except for any intervening h and w (American census only), then omit all but the first.<br>
   				5. Return the first four characters, right-padding with zeroes if there are fewer than four.<br><br>			
				";
				$ex = "
				Using this algorithm, both \"Robert\" and \"Rupert\" return the same string \"R163\"<br> while \"Rubin\" yields \"R150\".<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 21:
				//jaro-winkler
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name ." WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Jaro-Winkler Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Jaro-Winkler</B>",$msg));
				$desc = "This filter generates a temporary data table based on Jaro-Winkler Algorithm with the possible coincidences between the values of a an determinate number of attributes.<br><br>
				Jaro-Winkler Algorithm is a measure of similarity between two strings.<br>
				The Jaro distance metric states that given two strings s1 and s2, their distance dj is:<br><br>
			    <center><img src='../../icons/jaroformula.JPG'></center><br>
				Where:<br>
				m is the number of \"matching\" characters;<br>
    			a and b are the lengths of s1 and s2, respectively;<br>
    			t is the number of \"transpositions\".<br><br>
				";
				$ex = "
				The jaro-Winkler Distance between GUERRERO and AGUIRRE is 0.779761904762 and needs 3 operation to transform GUERRERO to AGUIRRE<br>
				1. Add A.<br>				
				2. Replace E for I.<br>
				3. Delete RO.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 22:
				//Double Metaphone
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name ." WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of string type attributes<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Double Metaphone Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Double Metaphone</B>",$msg));
				$desc = "This filter generates a temporary data table based on Double Metaphone Algorithm with the possible coincidences between the values of a an determinate number of attributes.<br><br>
				The Double Metaphone search algorithm is a phonetic algorithm.<br>
				It is called \"Double\" because it can return both a primary and a secondary code for a string; this accounts for some ambiguous cases as well as for multiple variants of surnames with common ancestry.<br>
				Double Metaphone tries to account for myriad irregularities in English of Slavic, Germanic, Celtic, Greek, French, Italian, Spanish, Chinese, and other origin. Thus it uses a much more complex ruleset for coding than its predecessor; for example, it tests for approximately 100 different contexts of the use of the letter C alone.<br><br>
				";
				$ex = "
				Encoding the name \"Smith\" yields a primary code of SM0 and a secondary code of XMT, while the name \"Schmidt\" yields a primary code of XMT and a secondary code of SMT--both have XMT in common.
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 23:
				//change Attribute name
				$conten = "420,200";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');

				$filter = $table_name ;//. " WHERE Field != '$table_name"."_id';";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);
				$desc = "<B>Attribute:</B> List of all attribute types of the data table.";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);					
				$sql = "SHOW COLUMNS FROM $table_name;";
				$res = $con->query($sql);
				unset($column_names);
				while($row = $con->fetch($res)){
					$column_names .= $row['Field'] . "&&&";
				}				
				$desc = "<B>New attribute name:</B> Type the new name for the attribute<br>.";
				$alg_form->addTextField("name","Attribute Name","/^.+$/","Please type a valid string","false",$column_names,"This field name already exists in the table","","",$desc,30);
				$msg = "Change Attribute Name procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Change Attribute Name</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter allows to change the name of an attribute, it is used when the attribute names are too long.<br>
				";
				$ex = "
				Simlpy select an attribute and then especify the new name for it.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 24:
				//table encoder
				$conten = "400,320";
				$mov = "100,20";				
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');	
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();	
				$filter = $table_name ." WHERE Type = 'varchar(255)'";			
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = '';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes inside the data table.<br>";				
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "Table Encoder Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Table Encoder</B>",$msg));
				$desc = "
				This filter is useful to reduce the file size for Data Mining procedures.<br>
				It transform all diferent values to consecutive numbers and creates a new data table with the table name added \"_dd\" string to specify that it is only for information purposes.<br><br>
				These table is named a Data Dictionary for the encoded data table.<br>
				The Data Dictionary has 3 attributes:<br>
				- Code -> is the code that is assigned to each one of the different values inside the original data table.<br>
				- Attribute -> is the name of the attribute in wich is the value encoded.
				- Value -> is the original value for those attribute inside the original data table.				
				";
				$ex = "Original Data Table:<br><br>
				<center><img src='../../icons/encode1.JPG'></center><br><br>
				Encoded Data Table:<br><br>
				<center><img src='../../icons/encode2.JPG'></center><br><br>
				The Data Dictionary for that data Table is:<br><br>
				<center><img src='../../icons/encode3.JPG'></center><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 25:
				//table decoder
				$conten = "380,170";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$id_usu = $_SESSION["id_usu"];
				$filter = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu AND nom_tabla LIKE '%_dd'";
				$encdec = new EncDec();
				$combo_columns  = $encdec->jComboDD($filter,'nom_tabla',$con);
				$desc = "<B>DD Table:</B> list of Data Dictionary Data Tables existing for the user.<br>";
				$alg_form->addCombo("column","DD Table","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$msg = "Table Decoder Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Table Decoder</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter is useful to translate a encoded data table to make it understandable according to real data and not to numbers.<br>
				To translate any data table it is necessary to know the Data Dictionary based on wich will decode a table. (It could exist more than one Data Dictionary associated to another data table or file).<br>
				";
				$ex = "Encoded Data Table:<br><br>
				<center><img src='../../icons/encode2.JPG'></center><br><br>
				The Data Dictionary to use to decode that data Table is:<br><br>
				<center><img src='../../icons/encode3.JPG'></center><br><br>
				Decoded Data Table:<br><br>
				<center><img src='../../icons/encode1.JPG'></center><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 26:
				//table union
				$conten = "420,330";
				$mov = "100,20";				
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$msg = "Table Union Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Table Union</B>",$msg));
				$attDesc = "
				First Window:<br>
				<b>MultiSelect</b>: List of all Data Tables that user have (Only can be selected 2 Data Tables.)<br>
				Second Window:<br>
				<b>MultiSelect</b>: List of all attributes od Data Table 1.<br>
				<b>MultiSelect</b>: List of all attributes od Data Table 2.<br>
				The number of attributes selected for Data Table 1 and Data Table 2 must be the equal.<br><br>
				";
				$alg_form->setDescription($attDesc);
				$desc = "
				This filter allows to make the union of 2 Data Tables based on the same number of attributes.<br>
				If the Data Table 1 have 20 attributes and the Data Table 2 have 12 attributes then it's possible to make the union with 1 or up to 12 attributes in any order.<br>
				Everything depends of the attributes to join.<br><br>
				";
				$ex = "Select the 2 Data Tables:<br><br>
					<center><img src='../../icons/union1.JPG'></center><br><br>
					Select the attributes to join:<br><br>
					<center><img src='../../icons/union2.JPG'></center><br><br>
					Apply the filter.
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("xajax_StartUnion();");
				//$xres->script("xajax_InitStartUnion();");
				break;
			
			case 27:
				//String Null Clean (Mode)
				$conten = "450,195";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE TYPE = 'varchar(255)';";
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);				
				$desc = "<B>Attribute:</B> list of all attributes inside the data table";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);

				$combo_columns = "['MBA','Mode Based On The Attribute'],";
				$combo_columns .= "['MBC','Mode Based On Conditions']";
				$desc = "<B>Type of Mode:</B> list with two (2) options <br> &nbsp;<b>Mode Based On The Attribute</b> --> Replace Null values based on the most common value inside that attribute. <br> &nbsp;<b>Mode Based On Conditions</b> --> The same as the previous one but based on certain conditions of the attributes.";
				$alg_form->addCombo("typeofmode","Type of Mode","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);

				$msg = "String Null Clean Procedure.<br>&nbsp;";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>String Null Clean Filter</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";				
				$xres->script($alg_form->getForm($func));
				$desc = "
				This filter is useful to replace all the NULL values inside an attribute for the most common value inside the attribute or for the most common value based on some conditions.<br><br>
				";
				$ex = "
				Fill NULL values with the most common value in the attribute.<br>
				{a,b,f,y,g,a,h,r,a,f,a,a} Then NULL values will be replaced for \"a\".<br><br>
				Fill NULL values with the most common value based on conditions.<br>
				The most common value in field10 if field1 = 'A' and field2 = 'B' is 'H'.<br>
				Then fill field10 NULL values  with 'H'.<br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 28:
				//Email Cleaner
				$conten = "360,150";
				$mov = "220,120";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$filter = $table_name . " WHERE TYPE = 'varchar(255)';";				
				$encdec = new EncDec();
				$combo_columns = $encdec->jCombo($filter,$con);				
				$desc = "<B>Attribute:</B> list of string type attribute wich is considered email attribute<br>";
				$alg_form->addCombo("column","Attribute","'id', 'column_name'",$combo_columns,"Select an Attribute...","column_name",$desc);
				$msg = "Email Cleaner";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Email Cleaner Filter</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify('$id',0,'$table_name')";				
				$xres->script($alg_form->getForm($func));
				$desc = "This filter detects and suggests when e-mail is damaged.";
				$ex = "List of e-mail<br>
				<center><img src='../../icons/email1.JPG'></center><br><br>
				Detects and suggests
				<center><img src='../../icons/email2.JPG'></center><br><br>
				Correction
				<center><img src='../../icons/email3.JPG'></center><br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
			
			case 29:
				//binarize
				$conten = "400,320";
				$mov = "100,20";				
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');				
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();				
				$fromData = $encdec->jComboSelect($table_name,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = '';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes inside the data table.<br>";				
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				$msg = "Table Binarize Procedure<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Table Binarize</B>",$msg));
				$desc = "
				This filter is useful to reduce the file size for Data Mining procedures.<br>
				It transform all the diferent values to 1's ans 0'.<br><br>
				";
				$ex = "Original Data Table:<br><br>
				<center><img src='../../icons/encode1.JPG'></center><br><br>
				New Binary Data Table:<br><br>
				<center><img src='../../icons/encode2.JPG'></center><br><br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',0,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			
			case 30:
				//Metaphone
				$conten = "400,320";
				$mov = "100,20";
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				$name = "multiselect";
				$dataFields = "['id', 'column_name']";
				$encdec = new EncDec();
				$filter = $table_name ." WHERE Type = 'varchar(255)'";
				$fromData = $encdec->jComboSelect($filter,$con);
				$toData = "[]";
				$width = 150;
				$height = 140;
				$valueField = 'column_name';
				$displayField = 'column_name';
				$fieldLabel = 'Attributes availables';
				$fromLabel = 'Available Attributes';
				$toLabel = 'Selected Attributes';
				$desc = "<b>MultiSelect</b>: List of all attributes of data table<br>";
				$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
				
				$msg = "Metaphone Procedure (Selection Filter)<br>&nbsp; ";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Metaphone Search</B>",$msg));
				$desc = "Metaphone Search<br>This filter search all the possible similarities in two strings based on distances, that is to say, it search and shows all the words than could be appear equals.<br><br>
				Those distances means insert, modification or elimination of characters inside any of two strings.<br><br>
				While smaller it is the distance, more possibility it exists that the strings are the same ones.<br><br>
				For further precision this distance should be smaller or equal to 2.<br><br>";
				$ex = "
				- The Metaphone Distance between kitten and sitting is 3<br>
				&nbsp;&nbsp;&nbsp; (Replace k for s, Replace e for i and Insert g) Total : 3 Transformation steps<br><br>				
				- The Metaphone Distance between Ardila and Ardiya is 1<br>
				&nbsp;&nbsp;&nbsp; (Replace l for y) Total : 1 Transformation step<br><br>
				According to the above this filter will generate a temporary data table with the two rows Ardila and Ardiya respectively.<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 1;");
				$func = "xajax_Verify('$id',1,'$table_name')";
				$xres->script($alg_form->getForm($func));
				break;
			default:
				break;			
		}
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}	
	return $xres;
}

/**
	 * This function verify if an executed algorithm will be created on a new table
	 *
	 *@param string contains the Id of the algorithm
	 *@param integer flag to verify what kind of filter is executed. 0 -> goes to exec_algorithm, 1 -> goes to Gen_Dup, 2 -> goes to GenInvalidCCT
	 *@param string contains the table name on which is executed a filter
	 *@param string contains all the arguments coming from Algorithms function
 */
function Verify($id, $isselfil, $table_name, $Form){
	#isselfil determina si el diltro es de seleccion o no (1 -> si,0 -> no) para saber si ejecuta
	#exec_algorithm o GenDup
	$xres = new xajaxResponse();
	try {
		$Form = str_replace("'","\'",$Form);
		if($id == 29){
			$js = "Ext.MessageBox.hide(); xajax_Dup_tab('$id','$isselfil','$table_name','$Form');";
		}else{
			$con = new MySQLConex();
			session_start();
			$log = $_SESSION['nom_usu'];
			$cla = $_SESSION['cla_usu'];
			$con->abrir($log,$cla);
			//$sql = "SELECT COUNT(*) as n FROM tabxfile WHERE id_arch = (SELECT id_arch FROM tabxfile WHERE nom_tabla = '$table_name')";
			$sql = "SELECT nom_tabla AS n FROM tabxfile WHERE id_arch = (SELECT id_arch FROM tabxfile WHERE nom_tabla = '$table_name')";	
			$res = $con->query($sql);
			$row = $con->fetch($res);
			if($row['n'] != $table_name){
				if($id == 1 || $id==7 || $id==19){
					$reload = 1;
				}else{
					$reload = 0;
				}
			$js = "	Ext.MessageBox.hide();				
					Ext.MessageBox.confirm('Confirm','Do you want to apply this filter in a new table?', result);
					function result(btn){
						if(btn == 'yes'){
							xajax_Dup_tab('$id','$isselfil','$table_name','$Form');
						}else{
							Ext.MessageBox.wait('Processing Data', 'Please Wait');";
			if($isselfil == 1){
				$js.= "		xajax_GenDup('$id','$table_name','$table_name','$Form');";
			}elseif($isselfil == 2){
				$js.= "		xajax_GenInvalidCCT('1','$id','$table_name','$table_name','$Form')";		
				
			}else{
				$js.="		xajax_Exec_Algorithm('$reload','$id','$table_name','$table_name','$Form');";
			}
			$js.="
						}
					}
			";		
			}else{		
				$js = "Ext.MessageBox.hide(); xajax_Dup_tab('$id','$isselfil','$table_name','$Form');";
			}
			$con->cerrar();
		}
		$xres->script($js);
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
/**
	 * This function executes an algorithm
	 *
	 * 
	 *@param integer contains a flag to see the behavior of the data table
	 *@param string contains the Id of the algorithm
	 *@param string contains the table name if it is a new table
	 *@param string contains the table name if it is a base name
	 *@param string contains all the arguments coming from Algorithms function
 */
function Exec_Algorithm($reload,$id,$table_name,$base_name,$Form){
	$xres = new xajaxResponse();
	try {
		$Form = str_replace("'","\'",$Form);
		$encdec = new EncDec();
		$arr = $encdec->JDecode($Form);	
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$sql = "SELECT id_arch FROM tabxfile WHERE nom_tabla = \"$base_name\"";
		$res = $con->query($sql);
		$id_arch = $con->fetch($res);	
		switch ($id){
			case 1:
				$usedFilter = "Discretize";
				require_once('TransformFilters/Discretize.php');
				$dis = new Discretize();
				$answer = $dis->Discretizar($table_name,$arr['column'],$arr['bins'],$con);
				break;			
			case 2:
				$usedFilter = "NullClean";
				require_once('CleanFilters/NullClean.php');
				$nullC = new NullClean();				
				$ans = $nullC->NullClean($table_name,$arr['column'],$arr['func'],$con);
				$answer = $ans[1];
				break;			
			case 3:
				$usedFilter = "CharReplace";
				require_once('CleanFilters/CharReplace.php');
				$charR = new CharReplace();
				$arr['oldchar'] = urldecode($arr['oldchar']);
				$arr['newchar'] = urldecode($arr['newchar']);
				$fields = explode("%2C",$arr['column']);
				$answer = $charR->CharReplace($table_name,$fields,$arr['oldchar'],$arr['newchar'],$con);
				break;
			case 4:
				$usedFilter = "Change Attribute Type";
				$col1 = urldecode($arr['column']);
				$col1 = explode(" ",$col1);
				$col2 = urldecode($arr['column2']);
				$sql_cct = "UPDATE `$table_name` SET `$col1[0]` = NULL WHERE `$col1[0]` = '';";
				$con->query($sql_cct);
				unset($sql_cct);
				$sql_cct = "ALTER TABLE `$table_name` CHANGE COLUMN `$col1[0]` `$col1[0]` $col2 NULL";
				$con->query($sql_cct);
				$answer = "ok";
				break;
			case 5:
				$usedFilter = "Normalize";
				require_once('TransformFilters/Normalize.php');
				$dis = new Normalize();
				$answer = $dis->Normalize($table_name,$arr['column'],$con);
				break;			
			case 7:
				$usedFilter = "Delete Attributes";
				require_once('TransformFilters/Remove.php');
				$remove = new Remove();
				$args = $arr['multiselect'];				
				if ($remove->Remove($table_name,$args,$con)==0){
					$js = "
						Ext.MessageBox.alert('Alert', 'must be exists almost one attribute.');
						";
					$xres->script($js);
				}else{
					$answer = $remove->RetOk();
				}
				$answer = 'ok';
				break;
			case 10:
				$usedFilter = "Expert Rule Editor";
				unset($sql, $sqlarr);			
				$sqlarr = explode("s|s|",$Form);				
				$nom_usu = $_SESSION['nom_usu'];
				$new_table = "tmp_" . $nom_usu;
				
				require_once('../../class/msg/AlgDialog.php');
				require_once('../../class/gui/GridPhp/gridclass.php');
				require_once('CleanFilters/Missing.php');

				$GenTable = new Missing();
				$ban = false;
				foreach ($sqlarr as $sql){
					$sql = str_replace("t|t|"," $table_name ", $sql);
					$sql = str_replace("\'","'", $sql);	
					$sql = urldecode($sql);
	
					if (substr($sql,0,6)=='INSERT') {
						$GenTable->ShowTmpTable($table_name, $new_table, $con);					
						$con->query($sql);
						$ban = true;
						
					}else {
						$con->query($sql);
					}
				}				
				if($ban==true){				
					$conten = "600,530";
					$mov = "20,10";
					$CCT = new AlgDialog($conten,$mov,'algorithm-aux');					
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Expert Rule Editor (Temporary Data Table)</B>","550",$msg));
					$desc = "
					This window shows a temporary data table that contains all the rows that fulfilled the specifications given by Expert Rule Editor using the \"SHOW\" sentence.<br><br>
					It can be carried out two operations on that data table:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/experteditor3.JPG'></center><br><br>
					Expert Rule Editor Window:<br><br>
					<center><img src='../../icons/experteditor1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/experteditor2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					$msg = "The following rows of <b>$table_name </b> fulfilled the Expert Rule Editor conditions.<br><br> Editable Attributes:	-All<br>&nbsp;";
					$xres->assign('description_alg','innerHTML',$msg);
					$query = "8";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);			
					$grid->setForm();
					$js = $grid->define_grid($con,"false");					
					$xres->assign('description_alg','innerHTML',$msg);
					$xres->script($js);
				}
				$answer = "ok";		
				break;
			case 12:
				$usedFilter = "Upper Case";
				unset($sql);
				$sql = "UPDATE $table_name SET";			
				$fields = explode("%2C",$arr['multiselect']);
				foreach ($fields as $field){
					$sql .= " $field = UCASE($field),";
				}			
				$sql = substr($sql,0,strlen($sql)-1);
				$con->query($sql);
				$answer = "ok";
				break;
			case 13:
				$usedFilter = "Lower Case";
				unset($sql);
				$sql = "UPDATE $table_name SET";			
				$fields = explode("%2C",$arr['multiselect']);
				foreach ($fields as $field){
					$sql .= " $field = LCASE($field),";
				}
				$sql = substr($sql,0,strlen($sql)-1);			
				$con->query($sql);
				$answer = "ok";
				break;
			case 14:
				$usedFilter = "Trim";
				unset($sql);
				$sql = "UPDATE $table_name SET";
				$fields = explode("%2C",$arr['multiselect']);
				foreach ($fields as $field){
					$sql .= " $field = TRIM($field),";
				}
				$sql = substr($sql,0,strlen($sql)-1);
				$con->query($sql);
				$answer = "ok";
				break;		
			case 17:
				$usedFilter = "Truncate String";
				$field = $arr['column'];
				$length = $arr['length'];
				unset($sql);
				if ($arr['truncate']=='Right') {
					$sql = "UPDATE $table_name SET $field = SUBSTRING($field,1,$length) WHERE LENGTH($field) > $length;";
				}else {
					$length = $length + 1;
					$sql = "UPDATE $table_name SET $field = SUBSTRING($field,$length)";
				}
				$con->query($sql);
				$answer = "ok";
				break;
					
			case 18:
				$usedFilter = "Attribute Clear";
				$field = $arr['column'];
				unset($sql);
				$sql = "UPDATE $table_name SET $field = NULL;";
				$con->query($sql);
				$answer = "ok";
				break;	
			case 19:
				$usedFilter = "Add Attribute";
				$name = $arr['name'];
				$type = $arr['type'];
				unset($sql);			
				$sql = "ALTER TABLE $table_name ADD $name $type;";
				$con->query($sql);
				$answer = "ok";
				break;
			case 23:
				$usedFilter = "Change Attribute Name";
				$field = $arr['column'];
				$name = $arr['name'];
				unset($sql, $sql2);
				$sql = "SHOW COLUMNS FROM $table_name WHERE Field = '$field'";
				$res = $con->query($sql);
				$row = $con->fetch($res);
				$sql2 = "ALTER TABLE $table_name CHANGE COLUMN  $field $name " . $row["Type"] .";";
				$con->query($sql2);
				$reload = 1;
				$answer = "ok";
				break;
			case 24:
				$usedFilter = "Encode";
				require_once("TransformFilters/Encode.php");
				$encode = new Encode();
				$fields = explode("%2C",$arr['multiselect']);
				$dd = $table_name."_dd";
				//
				$time = new timer();
				$init_timer = $time->microtime_float();				
				//
				$answer = $encode->EncodeAtribute($table_name,$dd,$fields,$con);
				//
				$end_timer = $time->microtime_float();
				$end_timer = round(($end_timer - $init_timer),3);
				//
				$sql = "SELECT COUNT(*) FROM tabxfile WHERE nom_tabla = '$dd'";				
				$res = $con->query($sql);
				$number = $con->fetch($res);
				$reload = 2;				
				if($number[0] == 0){
					$sql = "INSERT INTO tabxfile values(''," . $id_arch['id_arch'] .",'$dd','Encode');";
					$con->query($sql);
				}
				break;
			case 25:
				$usedFilter = "Decode";
				require_once("TransformFilters/Encode.php");
				$encode = new Encode();
				$dd = $arr['column'];
				$answer = $encode->DecodeAtribute($table_name,$dd,$con);
				break;
			case 27:
				///string clean
				$usedFilter = "String Clean - mode based";
				require_once("CleanFilters/StringMode.php");
				$column = $arr['column'];
				$typeOfMode = urldecode($arr['typeofmode']);
				$SM = new StringMode($table_name,$column,$con,$log);
				if($typeOfMode == 'Mode Based On The Attribute'){
					$answer = $SM->attributeBased();					
				}else{
					$reload = 3;
					require_once("../../class/msg/algorithmForm.php");
					$xres->script("Ext.MessageBox.hide();");					
					$conten = "480,450";
					$mov = "100,20";
					$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
					$msg = "<center>String Null Clean Based on Conditions<br>Attribute Target of Cleaning: <b>$column</b>&nbsp;</center>";
					$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Mode Based on Conditions</B>",$msg));
					$att_desc = "
					First Window:<br>
					<b>MultiSelect</b> : List of all attributes of the Data Table except the Target one.<br>
					Second Window:<br>
					<b>Dynamic</b>: Here 3 columns are created with all the attributes that have been selected in the previous window.<br>
					<b>- First Column : </b> It has the attribute name.<br>
					<b>- Second Column : </b> It has a combo box with 6 different options (Equally, Bigger, Smaller Bigger Than, Smaller Than, Different, Like).<br>
					<b>- Third Column : </b> It has a text box in which will be typed de value for the condition.<br><br>
					";
					$alg_form->setDescription($att_desc);
					$desc = "
					This filter is useful to replace all the NULL values inside an attribute for the most common value inside the attribute or for the most common value based on some conditions.<br><br>
					";
					$ex = "
					Fill NULL values with the most common value in the attribute.<br>
					{a,b,f,y,g,a,h,r,a,f,a,a} Then NULL values will be replaced for \"a\".<br><br>
					Fill NULL values with the most common value based on conditions.<br>
					The most common value in field10 if field1 = 'A' and field2 = 'B' is 'H'.<br>
					Then fill field10 NULL values  with 'H'.<br><br>
					";
					$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
					$xres->script($alg_form->getJS());
					if($table_name == $base_name){
						$cancelstringban = 0;
					}else{
						$cancelstringban = 1;
					}
					$xres->script("xajax_StartStringMode('$table_name','$column','$cancelstringban')");
				}
				break;
			case 28:
				$reload = 2;
				$usedFilter = "Email Cleaner";
				require_once("CleanFilters/EmailCleaner.php");
				require_once("../../class/msg/AlgDialog.php");
				require_once('../../class/gui/GridPhp/gridclass.php');				
				$nom_usu = $_SESSION['nom_usu'];
				$new_table = "tmp_" . $nom_usu;
				$column = $arr['column'];
				$EC = new EmailCleaner();
				$EC->EmailCleaner($table_name,$new_table,$column,$con);
					$conten = "600,530";
					$mov = "20,10";
					$CCT = new AlgDialog($conten,$mov,'algorithm-aux');
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Email Cleaner</B>","550",$msg));
					$desc = "
					This window shows a temporary data table that contains two attributes:<br>
					The first one have the attribute selected as an email attribute and shows al the values that doesn't coincide with an email structure.<br>
					The second one shows a possible suggestion to those incorrect values.<br><br>
					All the suggestions are based in defined rules to construct an email structure.<br><br>
					It can be carried out four operations on that data table:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Use All Corrections:</b> To change all the invalid emails by the suggestions.<br><br>
					<b>Change Values:</b> To double click event inside the second column is possible to edit de value of the suggestion.<br><br>					
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/emailclean1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/emailclean2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					$msg = "The following rows of <b>$table_name </b> cannot be converted, please verify it.<br><br> Editable Attributes:	-Suggest_".$column."<br>&nbsp;";
					$xres->assign('description_alg','innerHTML',$msg);
					$query = "8";
					$editable = "Suggest_".$column.",Accept_".$column;
					$grid = new standardgrid($new_table,$editable,$query,'table_alg','',$id,$table_name);
					$grid->UseCorrections();
					$grid->setForm();
					$js = $grid->define_grid($con,"false");				
					$xres->assign('description_alg','innerHTML',$msg);
					$xres->script($js);				
					$answer = "ok";				
				break;
			case 29:
				require_once("TransformFilters/binarize.php");
				$usedFilter = "Binarize";
				$args = $arr['multiselect'];
				//
				$time = new timer();
				$init_timer = $time->microtime_float();				
				//
				$binarize = new Binarize();
				$answer = $binarize->makeIt($base_name,$table_name,$args,$con);
				//
				$end_timer = $time->microtime_float();
				$end_timer = round(($end_timer - $init_timer),3);

				//
				break;				
			default:
				break;
		}
		if($answer == "ok"){
			$xres->script("Ext.MessageBox.hide();");
		}
		if($table_name != $base_name){
			$sql = "INSERT INTO tabxfile values(''," . $id_arch['id_arch'] .",'$table_name','$usedFilter');";
			$con->query($sql);
		}else {
			$sql = "UPDATE tabxfile SET descripcion = '$usedFilter' WHERE nom_tabla = '$table_name';";
			$con->query($sql);
		}
		if ($reload == 0) {
			$js = "ds.reload();";
			$xres->script($js);
		}elseif ($reload != 3){
			$js = "
			if(grid_is_load){
				grid.destroy(true);
				grid_is_load = false;
				generalTabs.hideTab('Statistics');
			}	
			";
			$xres->script($js);
			$xres->script("xajax_grid('".$table_name ."');");
		}
		$xres->script("xajax_tree();");
		if ($answer == "ok" && $id == 2){
			$js = "Ext.MessageBox.alert('Success', '".$ans[0]."');";
			$xres->script($js);
		}
		$con->cerrar();
	}catch (Exception $e){
		$xres->script("Ext.MessageBox.hide();");
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
/**
	 * This function shows the form to write a new table name
	 *
	 * 
	 *@param string contains the Id of the algorithm
	 *@param integer flag to verify what kind of filter is executed. 0 -> goes to exec_algorithm, 1 -> goes to Gen_Dup, 2 -> goes to GenInvalidCCT
	 *@param string contains the table name (base name)
	 *@param string contains all the arguments coming from Algorithms function
 */
function Dup_tab($id, $isselfil, $base,$Form){	
	$xres = new xajaxResponse();
	try {
		require_once("../../class/msg/algorithmForm.php");	
		$Form = str_replace("'","\'",$Form);
		
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$id_usu = $_SESSION['id_usu'];
		$nom_usu = $_SESSION['nom_usu'];
		$conten = "380,190";
		$mov = "220,120";
		$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
		$sql = "select nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$res = $con->query($sql);
		unset($table_names);
		while($row = $con->fetch($res)){
			$table_names .= $row['nom_tabla'] . "&&&";
		}
		$regexText = "Invalid name";
		$invalidText = "This table name, already exists. please type a new name";
		$beforeext = $nom_usu ."_";
		$desc = "<b>Table Name</b> : The new table name for applyed procedure or algorithm.<br>";
		$alg_form->addTextField('new_name','Table Name',"/^[a-zA-Z]+[a-zA-Z0-9]*$/",$regexText,"false",$table_names,$invalidText,$beforeext,"",$desc,15);
		$msg = "<center>The name typed will be added <br> the '". $nom_usu . "_ NAME' value <br>&nbsp;</center>";
		$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("Table Name",$msg));
		$desc = "
		this window is used to specify the new table name associated with the procedure or filter applyed.<br>
		";
		$ex = "Simply type the new table name. this table name must not exists in the left tree of main window.<br>";
		$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
		$xres->script($alg_form->getJS());
		$xres->script("SBItemStat = 0;");
		$func = "xajax_Create_dup('$beforeext','$id','$isselfil','$base','$Form')";
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
/**
	 * This function create a new table
	 *
	 * 
	 *@param string contains the Id of the algorithm
	 *@param integer flag to verify what kind of filter is executed. 0 -> goes to exec_algorithm, 1 -> goes to Gen_Dup, 2 -> goes to GenInvalidCCT
	 *@param string contains the table name (base name)
	 *@param string contains all the arguments coming from Algorithms function
	 *@param string contains the value of the new data table (stablished, don't use)
 */
function Create_dup($beforeext,$id,$isselfil,$base,$Form,$duplicate){
	$xres = new xajaxResponse();
	try {
		$Form = str_replace("'","\'",$Form);
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$k_v = explode('=',$duplicate);
		$duplicate = $beforeext. trim($k_v[1]);
		
		$sql = "DROP TABLE IF EXISTS $duplicate";	
		$con->query($sql);
		$sql = "CREATE TABLE $duplicate SELECT * FROM $base";	
		$con->query($sql);
		$sql ="
			ALTER TABLE $duplicate
			CHANGE COLUMN   `$base" . "_id` `$duplicate" ."_id` double NOT NULL DEFAULT '0';
		";
		$con->query($sql);
		$con->cerrar();	
		$js = "
		Ext.MessageBox.wait('Processing Data', 'Please Wait');";
		if ($isselfil == 0) {
			$js.="
			xajax_Exec_Algorithm('2','$id','$duplicate','$base','$Form');";		
		}elseif($isselfil == 2){
			$js.= "
			xajax_GenInvalidCCT('2','$id','$duplicate','$base','$Form')";
		}else{
			$js.="
			xajax_GenDup('$id','$duplicate','$base','$Form');";
		}
		$xres->script($js);
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

/**
 * this function applys to Change Column Type
 * id --> the algorithm id
 * table_name --> the table name
 * Form --> the data from the 2 comboboxes
 * 			first --> column name and type. EX: field1 varchar(255)
 * 			second --> the new type for the column
 * 
 * Description-->
 * 			this function has to generate a new layout with an editable grid inside
 * 			who shows all the fields with their respective rows, that doesn´t coincide with the new type defined in Form[second].
 * 			
 * */
  function GenInvalidCCT($reload, $id, $table_name, $base_name,$Form){
	$xres = new xajaxResponse();
	try {
		$js = "Ext.MessageBox.hide();";
		$xres->script($js);
	 	$encdec = new EncDec();
		$arr = $encdec->JDecode($Form);
		$col1 = urldecode($arr['column']);
		$col1 = explode(" ",$col1);
		$col2 = urldecode($arr['column2']);	
		switch ($col2) {		
			case "varchar(255)":
				$js = "xajax_Exec_Algorithm('$reload','$id','$table_name','$base_name','$Form');";		
				$xres->script($js);
				break;
				
			case "double";
				require_once('../../class/msg/AlgDialog.php');
				require_once('TransformFilters/ChangeColumnType.php');
				require_once('../../class/gui/GridPhp/gridclass.php');
				$xres->script("Ext.MessageBox.hide();");
				session_start();
				$nom_usu = $_SESSION['nom_usu'];
				$new_table = "tmp_" . $nom_usu;
				$column= $col1[0];
				$con = new MySQLConex();
				$log = $_SESSION['nom_usu'];
				$cla = $_SESSION['cla_usu'];
				$con->abrir($log,$cla);
				$Change = new ChangeColumnType();
				$answer = $Change->ChangeColumnToDouble($table_name, $new_table, $column, $con);

				if($answer['count']>0 && $answer['answer'] == "ok"){
					$conten = "600,530";
					$mov = "20,10";
					$CCT = new AlgDialog($conten,$mov,'algorithm-aux');
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Change Attribute Type</B>","550",$msg));
					$desc = "
					This window shows a temporary data table that contains all the values of the selected attribute that don't fulfill with the data type.<br>
					It can be carried out six operations on that data table:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Delete All:</b> To delete all the invalid values that doesn't allow to change the attribute type.<br><br>
					<b>Change All By:</b> To replace all the invalid values for an especific one.<br><br>
					<b>Change Values:</b> To double click event inside the editable column is possible to edit de value.<br><br>
					<b>Analize:</b> To verify if all the new values are according to the new data type specified for the attribute. If not, those values will be shown again in this data table.<br><br>
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/changeatt_type1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/changeatt_type2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					
					$xres->script($CCT->getDLG());
					$msg = "The following rows of <b>$table_name </b> cannot be converted, please verify it.<br><br> Editable Attribute:	-$col1[0]<br>&nbsp;";
					$xres->assign('description_alg','innerHTML',$msg);
					$query = "8";
					$grid = new standardgrid($new_table,$column,$query,'table_alg',$Form,$id,$table_name,$base_name);
					$grid->addReplace();
					$grid->setForm($reload);
					$js = $grid->define_grid($con,"false",$reload);
					$xres->assign('description_alg','innerHTML',$msg);
					$xres->script($js);
					//
				}else {
					$js = "
					Ext.MessageBox.wait('Processing Data', 'Please Wait');
					xajax_Exec_Algorithm('$reload','$id','$table_name','$base_name','$Form');";
					$xres->script($js);
				}
				$con->cerrar();
				break;
				
			case "int(11)";
					
				require_once('../../class/msg/AlgDialog.php');
				require_once('TransformFilters/ChangeColumnType.php');
				require_once('../../class/gui/GridPhp/gridclass.php');
				$xres->script("Ext.MessageBox.hide();");
				session_start();
				$nom_usu = $_SESSION['nom_usu'];
				$new_table = "tmp_" . $nom_usu;
				$column= $col1[0];
				$con = new MySQLConex();
				$log = $_SESSION['nom_usu'];
				$cla = $_SESSION['cla_usu'];
				$con->abrir($log,$cla);
				$Change = new ChangeColumnType();
				$answer = $Change->ChangeColumnToInt($table_name, $new_table, $column, $con);
				if($answer['count']>0 && $answer['answer'] == "ok"){
					$conten = "600,530";
					$mov = "20,10";
					$CCT = new AlgDialog($conten,$mov,'algorithm-aux');
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Change Attribute Type</B>","550",$msg));
					$desc = "
					This window shows a temporary data table that contains all the values of the selected attribute that don't fulfill with the data type.<br>
					It can be carried out six operations on that data table:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Delete All:</b> To delete all the invalid values that doesn't allow to change the attribute type.<br><br>
					<b>Change All By:</b> To replace all the invalid values for an especific one.<br><br>
					<b>Change Values:</b> To double click event inside the editable column is possible to edit de value.<br><br>
					<b>Analize:</b> To verify if all the new values are according to the new data type specified for the attribute. If not, those values will be shown again in this data table.<br><br>
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/changeatt_type1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/changeatt_type2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					
					$xres->script($CCT->getDLG());
					$msg = "The following rows of <b>$table_name </b> cannot be converted, please verify it.<br><br> Editable Attribute:	-$col1[0]<br>&nbsp;";
					$xres->assign('description_alg','innerHTML',$msg);
					$query = "8";
					$grid = new standardgrid($new_table,$column,$query,'table_alg',$Form,$id,$table_name,$base_name);
					$grid->addReplace();
					$grid->setForm($reload);
					$js = $grid->define_grid($con,"false",$reload);
					$xres->assign('description_alg','innerHTML',$msg);
					$xres->script($js);
				}else {
					$js = "
					Ext.MessageBox.wait('Processing Data', 'Please Wait');
					xajax_Exec_Algorithm('$reload','$id','$table_name','$base_name','$Form');";
					$xres->script($js);
				}
				$con->cerrar();
				
				break;
				
			case "date":
	
				$xres->script("Ext.MessageBox.hide();");
				
				$conten = "420,200";
				$mov = "220,120";
				
				require_once("../../class/msg/algorithmForm.php");
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
				
				$combo_func = "['__YMD__','YMD'],";
				$combo_func .= "['__YDM__','YDM'],";
				$combo_func .= "['__DMY__','DMY'],";
				$combo_func .= "['__DYM__','DYM'],";
				$combo_func .= "['__MDY__','MDY'],";
				$combo_func .= "['__MYD__','MYD']";
				
				$desc = "<B>Date Format:</B> List of date formats";
				$alg_form->addCombo("dformat","Date Format","'id', 'dateformat'",$combo_func,"Select Date Format...","dateformat",$desc);
				$desc = "<B>Separator:</B> The separator can be -, /, |";
				$alg_form->addTextField('del','Date Delimiter',"/^.$/",$regexText,"false",'','','','',$desc,30);
				$msg = "<center>Date Options</center><br>";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Date Options</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify_Change('$reload','$id','$table_name','$base_name','$Form')";
				$xres->script($alg_form->getForm($func));
				$desc = "In this section must be expecified the format date in which is the attribute selected and the
						date delimiter.";
				$ex = "
				<center><img src='../../icons/cattodate1.JPG'></center><br>
				See the image and note the data structure, according to this the Date Format and Separator, text boxes must be filled with:<br>
				<center><img src='../../icons/cattodate2.JPG'></center><br>
				<br>
				";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
	
			case "datetime":
	
				$xres->script("Ext.MessageBox.hide();");
	
				$conten = "420,220";
				$mov = "220,120";
	
				require_once("../../class/msg/algorithmForm.php");
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
	
				$combo_func = "['__YMD__','YMD'],";
				$combo_func .= "['__YDM__','YDM'],";
				$combo_func .= "['__DMY__','DMY'],";
				$combo_func .= "['__DYM__','DYM'],";
				$combo_func .= "['__MDY__','MDY'],";
				$combo_func .= "['__MYD__','MYD']";
	
				$desc = "<B>Date Format:</B> List of date formats";
				$alg_form->addCombo("dformat","Date Format","'id', 'dateformat'",$combo_func,"Select Date Format...","dateformat",$desc);
				$desc = "<B>Separator:</B> The separator can be -, /, |";
				$alg_form->addTextField('del','Date Delimiter',"/^.$/",$regexText,"false",'','','','',$desc,1);
				$desc = "<B>Separator:</B> The separator can be :, ., |";
				$alg_form->addTextField('tim','Time Delimiter',"/^.$/",$regexText,"false",'','','','',$desc,1);
				$msg = "<center>Date, Time Options</center><br>";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Date, Time Options</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify_Change('$reload','$id','$table_name','$base_name','$Form')";
				$xres->script($alg_form->getForm($func));
				$desc = "In this section must be expecified: date format, date delimiter and time format in which are the attribute values selected .";
				$ex = "Especify the date delimiter, date format and time delimiter like is shown in the values structure";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;
				
			case "time":
	
				$xres->script("Ext.MessageBox.hide();");
	
				$conten = "420,220";
				$mov = "220,120";
	
				require_once("../../class/msg/algorithmForm.php");
				$alg_form = new algorithmForm($conten,$mov,'algorithm-dlg');
	
				$desc = "<B>Separator:</B> The separator can be :, ., |";
				$alg_form->addTextField('tim','Time Delimiter',"/^.$/",$regexText,"false",'','','','',$desc,1);
				$msg = "<center>Time Options</center><br>";
				$xres->assign('algorithm-dlg','innerHTML', $alg_form->getFormStruct("<B>Time Options</B>",$msg));
				$xres->script($alg_form->getJS());
				$xres->script("SBItemStat = 0;");
				$func = "xajax_Verify_Change('$reload','$id','$table_name','$base_name','$Form')";
				$xres->script($alg_form->getForm($func));
				$desc = "In this section must be expecified: time format in which are the attribute values selected .";
				$ex = "If the attribute values have a time structure, simply specify the time delimiter.";
				$xres->assign('help_div','innerHTML',$alg_form->getHtmlHelp($desc,$ex));
				break;	
	
			default:
				break;
		}
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
 	return $xres;
}

function CCTmptorigin($id, $table_tmp, $table_org, $value, $campo ,$Form){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$sql = "SELECT $table_tmp"."_id as row FROM $table_tmp;";
		$res = $con->query($sql);
		$sql = "";
		
		$x = 0;
		
		while ($row = $con->fetch($res)) {
			if ($x == 0){
				$sql = "UPDATE $table_org SET $campo = '$value' WHERE ";
			}
			$sql .= $table_org."_id = ".$row['row']." OR ";
			$x++;
			if ($x == 500){
				$sql = substr($sql,0,strlen($sql)-3) . ";";
				$con->query($sql);
				$x = 0;
			}
		}
		
		if($x > 0){
			$sql = substr($sql,0,strlen($sql)-3) . ";";
			$con->query($sql);
		}

		$con->cerrar();
	}catch (Exception $e){

	}
	return $xres;
}
function Verify_Change($reload,$id,$table_name,$base_name,$Form1,$Form){
	$xres = new xajaxResponse();	
	try {
		$encdec = new EncDec();
		$arr = $encdec->JDecode($Form1);
		
		$col1 = urldecode($arr['column']);
		$col1 = explode(" ",$col1);
		$column = $col1[0];
		$newtype = urldecode($arr['column2']);
		
		unset($arr);
		$arr = $encdec->JDecode($Form);
		$xres->script("Ext.MessageBox.wait('Processing Data', 'Please Wait');");
		switch ($newtype) {
			case 'date':
				$dformat = urldecode($arr['dformat']);
				$delimiter = urldecode($arr['del']);
				break;
			case 'datetime':
				$dformat = urldecode($arr['dformat']);
				$delimiter = urldecode($arr['del']);
				$timedel = urldecode($arr['tim']);
				break;
			case 'time':
				$timedel = urldecode($arr['tim']);
				break;
			default:
				break;
		}
		$dformat = urldecode($arr['dformat']);
		$delimiter = urldecode($arr['del']);
		require_once('../../class/msg/AlgDialog.php');
		require_once('TransformFilters/ChangeColumnType.php');
		require_once('../../class/gui/GridPhp/gridclass.php');
		
		session_start();
		$nom_usu = $_SESSION['nom_usu'];
		$new_table = "tmp_" . $nom_usu;
		
		$Change = new ChangeColumnType();
		
		$cone = new MySQLConex();		
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$cone->abrir($log,$cla);
		switch ($newtype) {
			
			case 'date':				
				$answer = $Change->ChangeColumnToDate($table_name, $new_table, $column, $dformat, $delimiter, $cone);			
				break;
				
			case 'datetime':
				$answer = $Change->ChangeColumnToDateTime($table_name, $new_table, $column, $dformat, $delimiter,$timedel, $cone);			
				break;
				
			case 'time':
				$answer = $Change->ChangeColumnToTime($table_name, $new_table, $column, $timedel, $cone);			
				break;	
					
			default:
				break;
		}
		if ($answer['answer'] == "ok"){
			if($answer['count']>0){
				$xres->script("Ext.MessageBox.hide();");
				$conten = "600,530";
				$mov = "20,10";
				$CCT = new AlgDialog($conten,$mov,'algorithm-aux');
				$CCT->setDescription('Nothing.<br><br>');
				$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Change Attribute Type</B>","550",$msg));
					$desc = "
					This window shows a temporary data table that contains all the values of the selected attribute that don't fulfill with the data type.<br>
					It can be carried out six operations on that data table:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Delete All:</b> To delete all the invalid values that doesn't allow to change the attribute type.<br><br>
					<b>Change All By:</b> To replace all the invalid values for an especific one.<br><br>
					<b>Change Values:</b> To double click event inside the editable column is possible to edit de value.<br><br>
					<b>Analize:</b> To verify if all the new values are according to the new data type specified for the attribute. If not, those values will be shown again in this data table.<br><br>
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/changeatt_type1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/changeatt_type2.JPG'></center><br><br>
					";
				$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
				$xres->script($CCT->getDLG());
				$msg = "The following rows of <b>$table_name </b> cannot be converted, please verify it.<br><br> Editable Attribute:	-$column<br>&nbsp;";
				$xres->assign('description_alg','innerHTML',$msg);
				$query = "8";		
				$grid = new standardgrid($new_table,$column,$query,'table_alg',$Form1,$id,$table_name,$base_name);
				$grid->addReplace();
				$grid->setForm($reload);
				$js = $grid->define_grid($cone,"false",$reload);			
				$xres->assign('description_alg','innerHTML',$msg);
				$xres->script($js);		
			}else {		
				switch ($newtype) {	
					case 'date':
						$repuesta = $Change->TransformToDate($table_name,$column,$dformat,$delimiter,$cone);
						break;				
					case 'datetime':
						$repuesta = $Change->TransformToDateTime($table_name,$column,$dformat,$delimiter,$timedel,$cone);
						break;			
					case 'time':
						$repuesta = $Change->TransformToTime($table_name,$column,$timedel,$cone);
						break;					
					default:
						break;
				}
				//$repuesta = $Change->TransformToDate($table_name,$column,$dformat,$delimiter,$cone);
				if($repuesta=='ok'){
					$js = "			
					xajax_Exec_Algorithm('$reload','$id','$table_name','$base_name','$Form1');";
					$xres->script($js);
				}else {
					$xres->script("Ext.MessageBox.hide();");
					$js = "Ext.MessageBox.alert('Status', 'The date attribute cannot be translated');";
					$xres->script($js);	
				}			
			}
		}else {
			$xres->script("Ext.MessageBox.hide();");
			$js = "Ext.MessageBox.alert('Status', 'The date attribute cannot be translated');";
			$xres->script($js);	
		}		$xres->script("Ext.MessageBox.hide();");
		$cone->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

/**
	 * This function applies if the selected algorithm is an Selection Algorithm
	 *
	 * 
	 *@param string contains the Id of the algorithm
	 *@param string contains the table name (new name)
	 *@param string contains the table name (base name)
	 *@param string contains all the arguments coming from Algorithms function	 
 */
function GenDup($id, $table_name, $base_name, $Form){
	$xres = new xajaxResponse();
	try {
		$Form = str_replace("'","\'",$Form);	
		$encdec = new EncDec();
		$arr = $encdec->JDecode($Form);
		$args = $encdec->JSBDecode($arr['multiselect']);
		if(count($args) == 0){
			$xres->script("Ext.MessageBox.hide();");
			$js = "Ext.MessageBox.alert('Status', 'Not exists any selected attribute.');";
			$xres->script($js);	
		}else{
			require_once('../../class/msg/AlgDialog.php');
			require_once('../../class/gui/GridPhp/gridclass.php');
			session_start();
			$nom_usu = $_SESSION['nom_usu'];
			$new_table = "tmp_" . $nom_usu;
			$con = new MySQLConex();			
			$log = $_SESSION['nom_usu'];
			$cla = $_SESSION['cla_usu'];
			$con->abrir($log,$cla);
			switch ($id){
				case 6:
					$usedFilter = "Table Details";
					$conten = "950,500";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");	
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Table Details</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the values of the selected attributes and adds a new column or attribute that shows the number of repetitions of those select attributes (like duplicates).<br>
					It is not editable but it can be carried out two operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/tabledetail1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/tabledetail2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());					
					$time = new timer();
					$init_timer = $time->microtime_float();
					require_once("SelectionFilters/tableDetails.php");
					$TD = new tableDetails();
					$answer = $TD->tableDetails($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "8";
					$msg = "Table Details<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"false");
					break;				
				case 8:
					//duplicates
					$usedFilter = "Duplicates Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");					
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Duplicates Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the duplicate values of the selected attributes.<br>
					It can be carried out four operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Delete All:</b> To delete all the values shown the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/duplicates2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/Duplicates.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$Dup = new Duplicates();
					$answer = $Dup->Duplicates($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "8";
					$atts = implode(",",$args);
					$msg = "The following rows of <b>$table_name </b> are duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"false");
					break;
				case 9:
					//levenshetein
					$usedFilter = "LD Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>LD Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the possible duplicate values of the selected attributes based on Levenshtein Distance.<br>
					This data table adds two new attributes(columns) that shows:<br><br>
					- id_own -> Is the id associated to that row.<br>
					- id_partner -> Is the id of other row to which this row has similarity.<br><br>					
					Those id_own and id_partner are useful to guide during cleaning process.<br>
					When id_partner is equal to zero (0) means that these row is a comparison base.<br><br>
					The lines shown in the temporary data table are useful to separate all the different results finded.<br><br>
					It can be carried out three operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/levenshtein.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/Levenshtein.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$levs = new Levenshtein();
					$answer = $levs->Levenshtein($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "9";
					$atts = implode(",",$args);
					$msg = "Levenshtein  -  The following rows of <b>$table_name </b> are posible duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;
				case 11:
					//nonprintable
					$usedFilter = "Non-Printable Character Search";
					require_once("CleanFilters/nonprintable.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$np = new nonprintable();
					$bandera = $np->nonprintable($table_name,$new_table,$args,$con);
					$answer = $bandera[0];
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);					
					if($answer == 0){
						$js = "Ext.MessageBox.alert('Status', '$end_timer Not exists any non-printable characters in the table.');";					
						$xres->script($js);
					}else{	
						$conten = "650,580";
						$mov = "5,3";
						$xres->clear("algorithm-aux","innerHTML");
						$CCT = new AlgDialog($conten,$mov,"algorithm-aux");							
						$xres->assign('algorithm-dlg','innerHTML', $CCT->getFormStruct("<B>Non-Printable Characters</B>","550",$msg,"yes"));
						$desc = "
						This window shows a temporary data table that contains all the nonprintable characters found inside the selected attributes.<br>
						It can be carried out six operations:<br><br>
						<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
						<b>Save Table:</b> To save these temporary data table.<br><br>
						<b>Change All By:</b> To replace all the values by an specific value.<br><br>
						<b>Change Values:</b> To double click event inside the editable column is possible to edit de new value that will replace the nonprintable character.<br><br>
						<b>Replace Characters:</b> Read all the new characters especified by the user and replace the nonprintale characters associates to them.<br><br>
						<b>Row context Menu:</b> It has one option:<br><br>
						<b>- Delete:</b> Delete the selected row from the temporary data table</b>.
						";
						$ex = "Non printable Characteres found in the original Data Table:<br><br>
						<center><img src='../../icons/nonprintable.JPG'></center><br><br>						
						";
						$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
						$xres->script($CCT->getDLG());
						$query = "8";
						if ($bandera[1] == "") {
							$bandera[1] = "Not Found";
						}
						$msg = "The following rows contains the non printable characters from <b>$table_name </b><br>Execution Time: &nbsp;<b> $end_timer</b> Seconds.<br>List of non-printable characters, associated with the attributes where they were found:<br><br>".$bandera[1] ."<br>";
						$encdec = new EncDec();
						$form = $encdec->Encode($args);
						$gridshow = new standardgrid("tmp2_".$new_table,'newchar',$query,'table_alg1',$form,$id,$table_name);
						$js2 = $gridshow->define_grid($con,"true");
						$xres->script($js2);
						$grid = new standardgrid($new_table,'newchar',$query,'table_alg',$form,$id,$table_name);
						$grid->addReplace();
						$grid->setForm();
						$js = $grid->define_grid($con,"false");
						$answer = "ok";
					}
					break;
				case 15:
					//max length
					$usedFilter = "Max Length";
					$conten = "950,500";
					$mov = "5,3";
					$encdec = new EncDec();
					$formula = $encdec->JDecode($Form);
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$xres->assign('algorithm-dlg','innerHTML', $CCT->getFormStruct("<B>Max Length</B>","850",$msg));
					$desc = "";
					$ex = "";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/MaxMinLength.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$levs = new MaxMinLength();
					$answer = $levs->MaxMinLength($table_name,$new_table,$formula,'Max',$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "8";
					$msg = "Maxlength<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;
				case 16:
					//min length
					$usedFilter = "Min Length";
					$conten = "950,500";
					$mov = "5,3";
					$encdec = new EncDec();
					$formula = $encdec->JDecode($Form);
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");	
					$xres->assign('algorithm-dlg','innerHTML', $CCT->getFormStruct("<B>Min Length</B>","850",$msg));
					$desc = "";
					$ex = "";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/MaxMinLength.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$levs = new MaxMinLength();
					$answer = $levs->MaxMinLength($table_name,$new_table,$formula,'Min',$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "8";
					$msg = "Maxlength<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;
				case 20:
					//soundex
					$usedFilter = "Soundex Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Soundex Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the possible duplicate values of the selected attributes based on Soundex Algorithm.<br>
					It can be carried out four operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Delete All:</b> To delete all the values shown the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/duplicates2.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/Soundexx.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$Sound = new Soundexx();
					$answer = $Sound->Soundex($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "8";
					$atts = implode(",",$args);
					$msg = "Soundex - The following rows of <b>$table_name </b> are posible duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"false");
					break;
				case 21:
					//jaro-Winkler
					$usedFilter = "Jaro-Winkler Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Jaro-Winkler Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the possible duplicate values of the selected attributes based on Jaro-Winkler algorithm.<br>
					It can be carried out three operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/jarowinkler.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/JaroWinkler.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$jarow = new JaroWinkler();
					$answer = $jarow->JaroWinkler($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "9";
					$atts = implode(",",$args);
					$msg = "Jaro-Winkler  -  The following rows of <b>$table_name </b> are posible duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;
				case 22:
					//double-metaphone
					$usedFilter = "Double Metaphone Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$CCT->setDescription('Nothing.<br><br>');
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Double Metaphone Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the possible duplicate values of the selected attributes based on Double Metaphone algorithm.<br>
					It can be carried out three operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/dblmetaphone.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/DMP.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$DM = new DMP();
					$answer = $DM->DMP($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "9";
					$atts = implode(",",$args);
					$msg = "Double Metaphone - The following rows of <b>$table_name </b> are posible duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;
				case 30:
					//metaphone
					$usedFilter = "Metaphone Search";
					$conten = "950,530";
					$mov = "5,3";
					$xres->clear("algorithm-aux","innerHTML");
					$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
					$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>LD Search</B>","850",$msg));
					$desc = "
					This window shows a temporary data table that contains all the possible duplicate values of the selected attributes based on Metaphone Distance.<br>
					This data table adds two new attributes(columns) that shows:<br><br>
					- id_own -> Is the id associated to that row.<br>
					- id_partner -> Is the id of other row to which this row has similarity.<br><br>					
					Those id_own and id_partner are useful to guide during cleaning process.<br>
					When id_partner is equal to zero (0) means that these row is a comparison base.<br><br>
					The lines shown in the temporary data table are useful to separate all the different results finded.<br><br>
					It can be carried out three operations:<br><br>
					<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
					<b>Save Table:</b> To save these temporary data table.<br><br>
					<b>Row context Menu:</b> It has two options:<br><br>
					<b>- Delete:</b> Delete the selected row from the temporary data table and <b>FROM THE ORIGINAL DATA TABLE</b>.
					<b>- Discard:</b> Delete the selected row from the temporary data table
					";
					$ex = "Original Data Table:<br><br>
					<center><img src='../../icons/duplicates1.JPG'></center><br><br>
					Temporary Data Table generated:<br><br>
					<center><img src='../../icons/Metaphone.JPG'></center><br><br>
					";
					$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
					$xres->script($CCT->getDLG());
					require_once("SelectionFilters/Metaphone.php");
					$time = new timer();
					$init_timer = $time->microtime_float();
					$met = new Metaphone();
					$answer = $met->MP($table_name,$new_table,$args,$con);
					$end_timer = $time->microtime_float();
					$end_timer = round(($end_timer - $init_timer),3);
					$query = "9";
					$atts = implode(",",$args);
					$msg = "Metaphone  -  The following rows of <b>$table_name </b> are posible duplicates<br><br>Base attributes: $atts<br>Execution Time: &nbsp;<b> $end_timer</b> Seconds<br>&nbsp;";
					$grid = new standardgrid($new_table,'*',$query,'table_alg','',$id,$table_name);
					$grid->setForm();
					$js = $grid->define_grid($con,"true");
					break;					
				default:
					break;
			}
			if($answer == "ok"){
				 $xres->script("Ext.MessageBox.hide();");
			}
			$xres->assign('description_alg','innerHTML',$msg);
			$xres->script($js);
			
			$sql = "SELECT id_arch FROM tabxfile WHERE nom_tabla = \"$base_name\"";
			$res = $con->query($sql);
			$id_arch = $con->fetch($res);
			if($table_name != $base_name){
				$sql = "INSERT INTO tabxfile values(''," . $id_arch['id_arch'] .",'$table_name','$usedFilter');";
				$con->query($sql);
			}
			$con->cerrar();
			$js = "
			if(grid_is_load){
				grid.destroy(true);
				grid_is_load = false;
				generalTabs.hideTab('Statistics');
			}	
			";
			$xres->script($js);
			$xres->script("xajax_grid('$table_name');");			
			$xres->script("xajax_tree();");			
		}
	}catch (Exception $e){
		$xres->script("Ext.MessageBox.hide();");
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function GenNPC($id, $tmp_table,$table,$form){	
	$xres = new xajaxResponse();
	try {
		require_once('CleanFilters/CharReplace.php');	
		$encdec = new EncDec();
		$args = $encdec->Decode($form);
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$CR = new CharReplace();
		$sql = "SELECT caracter, newchar FROM $tmp_table";
		$res = $con->query($sql);
		while ($row = $con->fetch($res)){
			$answer = $CR->CharReplace($table,$args,utf8_encode($row['caracter']),utf8_encode($row['newchar']),$con);
			
		}
		$xres->script("if(grid_is_load){
							grid.getDataSource().reload();
						}");
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function ruleEditor($id, $table_name, $Form){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$Form = str_replace("'","\'",$Form);
		$encdec = new EncDec();
		$arr = $encdec->JDecode($Form);
		require_once('CleanFilters/Missing.php');
		$editor = urldecode($arr['editor']);
		$ed = new Missing();
		$sqlarr = $ed->Missing($table_name,$editor,$con);
		$sqlarr = utf8_decode(str_replace("'","\'",$sqlarr));
		$xres->script("Ext.MessageBox.hide();");
		$xres->script("layoutIsOpen = false; dialog.hide(); dialog.destroy();");
		$func = "xajax_Verify('$id',0,'$table_name','$sqlarr')";
		$xres->script($func);
		$con->cerrar();
	}catch (Exception $e){
		$xres->script("Ext.MessageBox.hide();");
		if(substr_count($e->getMessage(), '1054') != 0){
			$xres->assign("msgDiv","innerHTML","Unknown attribute inside if clause");
		}elseif (substr_count($e->getMessage(), '1064') != 0){
			$xres->assign("msgDiv","innerHTML","Sintax error inside if clause");
		}elseif ($e->getMessage() == "123456789"){
			$xres->assign("msgDiv","innerHTML","Connection to server is lost.");
		}else{
			$xres->assign("msgDiv","innerHTML",$e->getMessage());
		}
		$con->cerrar();
	}
	return $xres;
}
//the following functions about Union.
function InitStartUnion(){
	$xres = new xajaxResponse();
	try {
		require_once("../../class/msg/algorithmForm.php");


	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function StartUnion(){
	$xres = new xajaxResponse();
	try {
		require_once("../../class/msg/algorithmForm.php");
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$xres->script("CleanMatch = 'match';");		
		$id_usu = $_SESSION["id_usu"];
		$conten = "420,545";
		$mov = "100,20";				
		$xres->clear("disc_div","innerHTML");
		
		$alg_form = new algorithmForm($conten,$mov,'','','','disc_div');
		$name = "multiselect";
		$dataFields = "['id', 'table_name']";
		$encdec = new EncDec();
		$filter = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$fromData = $encdec->jMatchComboSelect($filter,'nom_tabla',$con);				
		$toData = "[]";
		$width = 170;
		$height = 370;
		$valueField = 'table_name';
		$displayField = 'table_name';
		$fieldLabel = 'Available Attributes';
		$fromLabel = 'Available Tables';
		$toLabel = 'Selected Tables';
		$alg_form->resizeDialog($conten);
		$desc = "";
		$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
		$xres->script("SBItemStat = 1;");
		$func = "xajax_VerifyUnion('$id')";
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function VerifyUnion($id,$form){
	try {
		$xres = new xajaxResponse();
		require_once("../../class/msg/algorithmForm.php");
		$xres->script("CleanMatch = 'union';");
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$form = str_replace("'","\'",$form);	
		$encdec = new EncDec();
		$arr = $encdec->JDecode($form);
		$args = $encdec->JSBDecode($arr['multiselect']);
		$combo_columns[0] = $encdec->jComboSelect($args[0],$con);
		$fieldLabelOne = $args[0] . " Total Attributes " . $encdec->getNumRows();
		$combo_columns[1] = $encdec->jComboSelect($args[1],$con);
		$fieldLabelTwo = $args[1] . " Total Attributes " . $encdec->getNumRows();
		$xres->clear("disc_div","innerHTML");
		$alg_form = new algorithmForm($conten,$mov,'','','','disc_div');
		$desc = "<B>Attribute:</B> list of number type attributes";
		$name = "multiselect";
		$dataFields = "['id', 'attribute_name']";
		$encdec = new EncDec();
		$filter = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$toData = "[]";
		$width = 170;
		$height = 160;
		$valueField = 'attribute_name';
		$displayField = 'attribute_name';
		//$fieldLabel = 'Available Attributes';
		$fromLabel = 'Available Attributes';
		$toLabel = 'Selected Attributes';
		$conten = "430,545";
		$alg_form->resizeDialog($conten);
		$desc = "";
		$alg_form->addMultiselect($args[0],$fromLabel,$toLabel,$dataFields,$combo_columns[0],$toData,$width,$height,$valueField,$displayField,$fieldLabelOne,"false",$desc);
		$alg_form->addMultiselect($args[1],$fromLabel,$toLabel,$dataFields,$combo_columns[1],$toData,$width,$height,$valueField,$displayField,$fieldLabelTwo,"false",$desc);
		$xres->script("SBItemStat = 1;");
		$func = "xajax_DoUnion('$id')";		
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
		return $xres;
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
}

function DoUnion($id,$form){
	$xres = new xajaxResponse();
	try{
		$xres->script("CleanMatch = 'clean';");
		require_once("../../class/msg/algorithmForm.php");
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$form = str_replace("'","\'",$form);
		$encdec = new EncDec();		
		$arr = $encdec->JDecode($form);		
		$i = 0;
		foreach ($arr as $y => $w){
			$tables[$i] = trim($y);
			$fields[$i] = explode("%2C",$w);
			$i++;			
		}
		if(count($fields[0]) < count($fields[1])){
			throw(new Exception("The number of attributes selected in $tables[0] for matching are less than $tables[1]."));
		}elseif (count($fields[0]) > count($fields[1])){
			throw(new Exception("The number of attributes selected in $tables[1] for matching are less than $tables[0]."));
		}elseif (count($fields[0]) == 1 && count($fields[1]) == 1){
			if($fields[0][0] == '' && $fields[1][0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $tables[0] and in $tables[1]."));
			}elseif($fields[0][0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $tables[0]."));
			}elseif ($fields[1][0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $tables[1]."));	
			}			
		}		
		$id_usu = $_SESSION['id_usu'];
		$nom_usu = $_SESSION['nom_usu'];		
		require_once("SelectionFilters/Union.php");
		$union = new Union();
		$table_dest = "tmp_".$nom_usu;
		$answer = $union->doUnion($tables[0],$tables[1],$table_dest,$fields,$con);
		$file_name = 'Union_' . $tables[0].'_'.$tables[1];
		$conten = "380,190";
		$mov = "220,120";	
		$alg_form = new algorithmForm($conten,$mov,'algorithm-aux','contUnion_div','helpUnion_div','discUnion_div','msgDivUnion','dialog2');
		$sql = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$res = $con->query($sql);
		unset($table_names);
		while($row = $con->fetch($res)){
			$table_names .= $row['nom_tabla'] . "&&&";
		}
		$regexText = "Invalid name";
		$invalidText = "This table name, already exists. please type a new name";
		$beforeext = $nom_usu ."_";
		$alg_form->addTextField('new_name','Table Name',"/^[a-zA-Z0-9_]+$/",$regexText,"false",$table_names,$invalidText,$beforeext,"","",30);
		$msg = "<center>The name typed will be added <br> the '". $nom_usu . "_ NAME' value <br>&nbsp;</center>";
		$xres->clear('algorithm-aux','innerHTML');
		$xres->assign('algorithm-aux','innerHTML', $alg_form->getFormStruct("New Table Name",$msg));		
		$xres->script($alg_form->getJS());
		$xres->script("SBItemStat = 0;");
		$func = "xajax_ExecUnion('$beforeext','$table_dest','$file_name')";
		$xres->script($alg_form->getForm($func));		
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function ExecUnion($beforeext, $tmp_table, $file_name, $form){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$k_v = explode('=',$form);
		$new_table = $beforeext. trim($k_v[1]);	
		$sql = "DROP TABLE IF EXISTS $new_table";
		$con->query($sql);
		$sql = "CREATE TABLE $new_table SELECT * FROM $tmp_table";	
		$con->query($sql);	
		$sql ="
			ALTER TABLE $new_table
			CHANGE COLUMN   `$tmp_table" . "_id` `$new_table" ."_id` double NOT NULL DEFAULT '0';
		";
		$con->query($sql);		
		$id_usu = $_SESSION['id_usu'];
		$sql = "SELECT COUNT(*) FROM archivos WHERE arch_usu = '$file_name';";
		$res = $con->query($sql);
		$row = $con->fetch($res);
		if($row[0] == 0){
			$sql = "INSERT INTO archivos VALUES('',$id_usu,'" . $file_name . "','". date("y-m-d G:i:s") ."',1);";
			$con->query($sql);
			$tabxfile_id = $con->insertId();		
		}else {
			$sql = "SELECT id_arch FROM archivos where arch_usu = '$file_name';";
			$res = $con->query($sql);
			$fila = $con->fetch($res);
			$tabxfile_id = $fila['id_arch'];
		}
		$sql = "INSERT INTO tabxfile values('',$tabxfile_id,'$new_table','Table Union');";
		$con->query($sql);			
		$con->cerrar();	
		$js = "
		Ext.MessageBox.hide();
		xajax_tree();
		";
		$xres->script($js);
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function StartStringMode($table_name,$col_name,$cancelban){
	$xres = new xajaxResponse();	
	try {		
		require_once("../../class/msg/algorithmForm.php");		
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$xres->script("CleanMatch = 'stringmode';");
		$id_usu = $_SESSION["id_usu"];	
		$conten = "450,600";
		$mov = "100,20";				
		$xres->clear("disc_div","innerHTML");
		$alg_form = new algorithmForm($conten,$mov,'disc_div');
		$combo_func = "['all','All'],";
		$combo_func .= "['some','Those that fulfill the condition'],";
		$combo_func = substr($combo_func,0, strlen($combo_func)-1);
		$desc = "<B>Column:</B> List of number type attributes";
		$alg_form->addCombo("column","Fill the null values","'id', 'column_name'",$combo_func,"Select an option...","column_name",$desc);
		$name = "multiselect";
		$dataFields = "['id', 'table_name']";
		$filter = $table_name . " WHERE FIELD != '$col_name'";
		$encdec = new EncDec();
		$fromData = $encdec->jComboSelect($filter,$con);
		$toData = "[]";
		$width = 170;
		$height = 250;
		$valueField = 'table_name';
		$displayField = 'table_name';
		$fieldLabel = 'Available Attributes';
		$fromLabel = 'Available Attributes';
		$toLabel = 'Selected Attributes';		
		$desc = "";
		$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
		$xres->script("SBItemStat = 1;");
		if($cancelban == 1){
			$alg_form->setCancelFunc("xajax_cancelStringMode('$table_name');");
		}
		$func = "xajax_DoStringMode('$table_name','$col_name','$cancelban')";
		$xres->script($alg_form->getForm($func));
		$con->cerrar();		
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function DoStringMode($table_name,$col_name,$cancelban,$form){
	$xres = new xajaxResponse();
	try {
		$xres->script("CleanMatch = 'clean';");
		require_once("../../class/msg/algorithmForm.php");
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$form = str_replace("'","\'",$form);
		$encdec = new EncDec();		
		$arr = $encdec->JDecode($form);
		//if is all then send $on = 1 else $on = 2
		if($arr['column'] == 'All'){
			$on = 1;
		}else{
			$on = 2;
		}
		$args = $encdec->JSBDecode($arr['multiselect']);		
		$conten = "450,545";
		$mov = "100,20";				
		$xres->clear("disc_div","innerHTML");		
		$alg_form = new algorithmForm($conten,$mov,'disc_div');	
			$combo_func = "[['equally','equally'],";
			$combo_func .= "['bigger','bigger'],";
			$combo_func .= "['smaller','smaller'],";
			$combo_func .= "['bigger_than','bigger_than'],";
			$combo_func .= "['smaller_than','smaller_than'],";
			$combo_func .= "['diferent','diferent'],";
			$combo_func .= "['like','like']]";
		
		for($i = 0; $i < count($args); $i++){
			$alg_form->setComboColumnStore("$args[$i]","'id', 'column_name'",$combo_func);
		}
		for($i = 0; $i < count($args); $i++){
			if(strlen($args[$i]) < 20){
				$label = $args[$i];
			}else{
				$label = substr($args[$i],0,17). "...";
			}
			$alg_form->setComboColumnCont("$args[$i]","$label",'column_name','','equally');
		}
		$alg_form->setColumn('false',220);
		$alg_form-> freeColumn();
		for($i = 0; $i < count($args); $i++){
			$alg_form->setTextFieldColumn($args[$i]."|s|s|s"," ","/^.+$/","Please type a valid string","true","","","","","");
		}
		$alg_form->setColumn('true',160);
		$xres->script("SBItemStat = 0;");
		if($cancelban == 1){
			$alg_form->setCancelFunc("xajax_cancelStringMode('$table_name');");
		}
		$func = "xajax_ExecStringMode('$table_name','$col_name','$cancelban','$on')";		
		$xres->script($alg_form->getForm($func,120));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function ExecStringMode($table_name, $col_name, $cancelban, $on, $form){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$form = str_replace("'","\'",$form);
		$encdec = new EncDec();		
		$arr = $encdec->JDecode($form);
		foreach ($arr as $y => $w){
			$attY = trim($y);
			$attY2 = urldecode($attY);
			$attW = trim($w);			
			if(substr_count($attY2,'|s|s|s') == 0){
				$attributes[count($attributes)] = $attY2;	
				$operator[count($operator)] = $attW;
			}else{
				$value[count($value)] = $attW;
			}
		}
		require_once("CleanFilters/StringMode.php");
		$SM = new StringMode($table_name,$col_name,$con,$log);
		$answer = $SM->conditionBased($attributes,$operator,$value,$on);
		if ($cancelban == 1) {
			$js = "
			Ext.MessageBox.hide();
			if(grid_is_load){
				grid.destroy(true);
				grid_is_load = false;
				generalTabs.hideTab('Statistics');
			}
			";
			$xres->script($js);
			$xres->script("xajax_grid('".$table_name ."');");
			$xres->script("xajax_tree();");
		}else{
			$js = "
			ds.reload();
			Ext.MessageBox.hide();";
			$xres->script($js);	
		}
			require_once('../../class/msg/AlgDialog.php');
			require_once('../../class/gui/GridPhp/gridclass.php');
			$conten = "600,530";
			$mov = "20,10";
			$CCT = new AlgDialog($conten,$mov,'algorithm-aux');					
			$CCT->setDescription('Nothing.<br><br>');
			$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct("<B>Expert Rule Editor (Temporary Data Table)</B>","550",$msg));
			$desc = "
			This window shows a temporary data table that contains all the rows that fulfilled the specifications given by Expert Rule Editor using the \"SHOW\" sentence.<br><br>
			It can be carried out two operations on that data table:<br><br>
			<b>Export:</b> Based on anyone of the 4 file types (.CSV, .XLS, .SQL, .ARFF).<br><br>
			<b>Save Table:</b> To save these temporary data table.<br><br>
			";
			$ex = "This table shows the rows who were changed<br><br>";
			$xres->assign('table_help_div','innerHTML',$CCT->getHtmlHelpT($desc,$ex));
			$xres->script($CCT->getDLG());
			$msg = "The following rows of <b>$table_name </b> were changed.<br>&nbsp;";
			$xres->assign('description_alg','innerHTML',$msg);
			$query = "8";
			$id = 27;
			$grid = new standardgrid($answer,'',$query,'table_alg','',$id,$table_name);			
			$grid->setForm();
			$js = $grid->define_grid($con,"false");	
			$xres->assign('description_alg','innerHTML',$msg);
			$xres->script($js);
			$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function cancelStringMode($table_name){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$sql = "DROP TABLE IF EXISTS $table_name;";
		$con->query($sql);
		$sql = "SELECT id_tabla FROM tabxfile WHERE nom_tabla = '$table_name';";
		$res = $con->query($sql);
		$row = $con->fetch($res);
		$sql = "DELETE FROM tabxfile WHERE id_tabla = $row[0];";
		$con->query($sql);
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function Email_Update($id, $column, $value, $final_table, $table_name, $all){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$table_id = $final_table."_id";
		$sql = "SHOW COLUMNS FROM $table_name WHERE Field LIKE 'Suggest_%'";
		$res = $con->query($sql);
		$row = $con->fetch($res);
		$column_name = substr($row[0],8,strlen($row[0]));
		if($all == 'no'){
			$sql = "SHOW COLUMNS FROM $table_name WHERE Field LIKE 'Accept_%'";
			$res = $con->query($sql);
			$row = $con->fetch($res);
			$accept_column = $row[0];//substr($row[0],7,strlen($row[0]));
			$sql = "SELECT * FROM $table_name WHERE $accept_column = 1;";
		}elseif ($all == "yes") {
			$sql = "SELECT * FROM $table_name";
		}
		$res = $con->query($sql);
		while ($row = $con->fetch($res)) {
			$sql = "UPDATE $final_table SET $column_name = '$row[2]' WHERE $table_id = $row[0]";
			$con->query($sql);
		}
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
?>