<?php
class EmailCleaner{

	private $do;
	private $sim;
	private $en;
	private $cou;


	public function __construct(){		
		$this->do = array("com","edu","gov","org","net","mil","int","biz","coop","name","museum","udg");
		$this->sim = array(".","-","_","'","\"");
		$this->en = array("#","@","$","%","&");
		$this->cou = array("ac","ad","ae","af","ag","ai","al","am","an","ao","aq","ar","as","at","au","aw","ax","az","ba","bb","bd","be","bf","bg","bh","bi","bj","bl","bm","bn","bo","br","bs","bt","bv","bw","by","bz","ca","cc","cd","cf","cg","ch","ci","ck","cl","cm","cn","co","cr","cu","cv","cx","cy","cz","de","dj","dk","dm","do","dz","ec","ee","eg","eh","er","es","et","eu","fi","fj","fk","fm","fo","fr","ga","gb","gd","ge","gf","gg","gh","gi","gl","gm","gn","gp","gq","gr","gs","gt","gu","gw","gy","hk","hm","hn","hr","ht","hu","id","ie","il","im","in","io","iq","ir","is","it","je","jm","jo","jp","ke","kg","kh","ki","km","kn","kp","kr","kw","ky","kz","la","lb","lc","li","lk","lr","ls","lt","lu","lv","ly","ma","mc","md","me","mf","mg","mh","mk","ml","mm","mn","mo","mp","mq","mr","ms","mt","mu","mv","mw","mx","my","mz","na","nc","ne","nf","ng","ni","nl","no","np","nr","nu","nz","om","pa","pe","pf","pg","ph","pk","pl","pm","pn","pr","ps","pt","pw","py","qa","re","ro","rs","ru","rw","sa","sb","sc","sd","se","sg","sh","si","sj","sk","sl","sm","sn","so","sr","st","su","sv","sy","sz","tc","td","tf","tg","th","tj","tk","tl","tm","tn","to","tp","tr","tt","tv","tw","tz","ua","ug","uk","um","us","uy","uz","va","vc","ve","vg","vi","vn","vu","wf","ws","ye","yt","yu","za","zm","zw");
	}

	public function EmailCleaner($table_name, $table_dest, $campo, $con){

		try{

			$sql = "DROP TABLE IF EXISTS $table_dest";
			$con->query($sql);
			$sql = "CREATE TABLE $table_dest ($table_dest"."_id double NOT NULL, Email varchar(255) NOT NULL, Suggest_". $campo." varchar(255) NOT NULL, Accept_". $campo." int(11) NOT NULL);";
			$con->query($sql);
			$id = $table_name."_id";
			$sql = "SELECT $id, $campo FROM $table_name WHERE NOT ($campo = '' OR $campo IS NULL);";
			$res = $con->query($sql);
			while($fila = $con->fetch($res)){
				$answer = $this->Cleaner($fila[$campo]);
				if ($answer != "ok"){
					$sql = "INSERT INTO $table_dest VALUES ($fila[$id],'$fila[$campo]','$answer',1);";
					$con->query($sql);
				}
			}

		}catch (Exception $e){
			throw ($e);
		}
	}


	private function Cleaner($email){

		$correo = $email;

		while (in_array(substr($email,strlen($email)-1,strlen($email)),$this->sim)){
			$email = substr($email,0,strlen($email)-1);
		}
		while (in_array(substr($email,0,1),$this->sim)){
			$email = substr($email,1,strlen($email));
		}

		if (ereg("^[a-zA-Z0-9\._\-]+@[a-zA-Z0-9ñÑçÇ\-]+\.(([a-zA-Z]+(\.[a-zA-Z]{2})?)|([a-zA-Z]{2}))$",$email)) {

			$mail = explode('@',$email);

			$name = $mail[0];
			$last = explode(".",$mail[1]);
			$subdomine = $last[0];
			$domine = $last[1];

			if ($last[2]!=''){
				$country = $last[2];
			}

			if (strlen($country) == 0 && strlen($domine) == 2){
				$country = $domine;
				$domine = '';
			}

			$name = $this->name_evaluator($name);   //////Se evalua el nombre

			$subdomine = $this->subdomine_evaluator($subdomine);    ////// Se evalua el subdominio

			if ($domine != ''){
				$domine = $this->domine_evaluator($domine);
			}

			$sugest = $name."@".$subdomine.".".$domine.".".$country;

			$sugest = str_replace('..','.',$sugest);

			if ($country == ''){
				$sugest = substr($sugest,0,strlen($sugest)-1);
			}

			if($sugest == $correo){
				$sugest = "ok";
			}

		}else {

			if (ereg("^([a-zA-Z0-9_\.\-])+(#|@|$|%|&)([a-zA-Z0-9ñÑçÇ;,\.\-])+$",$email)) {

				$email = str_replace($this->en,'@',$email);

				$mail = explode('@',$email);

				$mail[1] = str_replace(',','.',$mail[1]);
				$mail[1] = str_replace(';','.',$mail[1]);

				$name = $this->name_evaluator($mail[0]);
				
				while (in_array(substr($mail[1],strlen($mail[1])-1,strlen($mail[1])),$this->sim)){
					$mail[1] = substr($mail[1],0,strlen($mail[1])-1);
				}
				while (in_array(substr($mail[1],0,1),$this->sim)){
					$mail[1] = substr($mail[1],1,strlen($mail[1]));
				}

				if (ereg("^[a-zA-Z0-9ñÑçÇ\-]+\.[a-zA-Z]+\.[a-zA-Z]{2,5}$",$mail[1])) {

					$last = explode(".",$mail[1]);
					$subdomine = $this->subdomine_evaluator($last[0]);
					$domine = $this->domine_evaluator($last[1]);
					$country = substr($last[2],0,2);
					$country = $this->country_evaluator($country);
					$sugest = $name."@".$subdomine.".".$domine.".".$country;

				}elseif (ereg("^[a-zA-Z0-9ñÑçÇ\-]+\.[a-zA-Z]{2}$",$mail[1])) {

					$last = explode(".",$mail[1]);
					$subdomine = $this->subdomine_evaluator($last[0]);
					$country = substr($last[1],0,2);
					$country = $this->country_evaluator($country);

					$sugest = $name."@".$subdomine.".".$country;  ///////////////sugerencia

				}elseif (ereg("^[a-zA-Z0-9ñÑçÇ\-]+\.[a-zA-Z]+$",$mail[1])) {

					$last = explode(".",$mail[1]);
					$subdomine = $this->subdomine_evaluator($last[0]);
					$domine = $this->domine_evaluator($last[1]);

					$sugest = $name."@".$subdomine.".".$domine;  ///////////////sugerencia

				}else{
					$sugest = "";
				}

			}else {	
				$sugest = "";
			}
		}

		return $sugest;
	}
	
	
	private function name_evaluator($name){

		while (in_array(substr($name,strlen($name)-1,strlen($name)),$this->sim)){
			$name = substr($name,0,strlen($name)-1);
		}
		while (in_array(substr($name,0,1),$this->sim)){
			$name = substr($name,1,strlen($name));
		}

		$cad = str_split($name);
		$cadena = "";
		$esc = false;
		$pun = false;

		for ($x=0;$x<strlen($name);$x++){
			if ($cad[$x] == "." && $esc == false && $pun == false){
				$cadena .= $cad[$x];
				$esc = true;
				$pun = true;
			}
			if ($cad[$x] == "_" && $esc == false){
				$cadena .= $cad[$x];
				$esc = true;
			}
			if ($cad[$x] == "-" && $esc == false){
				$cadena .= $cad[$x];
				$esc = true;
			}
			if (ereg("[a-zA-Z0-9]$",$cad[$x])) {
				$cadena .= $cad[$x];
				$esc = false;
			}
		}
		return $cadena;
	}


	private function subdomine_evaluator($subdomine){

		while (in_array(substr($subdomine,strlen($subdomine)-1,strlen($subdomine)),$this->sim)){
			$subdomine = substr($subdomine,0,strlen($subdomine)-1);
		}
		while (in_array(substr($subdomine,0,1),$this->sim)){
			$subdomine = substr($subdomine,1,strlen($subdomine));
		}

		$cad = str_split($subdomine);
		$cadena = "";
		$esc = false;

		for ($x=0;$x<strlen($subdomine);$x++){

			if ($cad[$x] == "-" && $esc == false){
				$cadena .= $cad[$x];
				$esc = true;
			}
			if (ereg("[a-zA-Z0-9]$",$cad[$x])) {
				$cadena .= $cad[$x];
				$esc = false;
			}
		}
		return $cadena;

	}

	private function domine_evaluator($domine){

		if (!in_array($domine,$this->do)){

			$d_m_corta = -1;

			foreach ($this->do as $p_actual) {

			    $lev = levenshtein($domine, $p_actual);

			    if ($lev <= $d_m_corta || $d_m_corta < 0) {
			        $p_m_cercana  = $p_actual;
			        $d_m_corta = $lev;
			    }
			}
			return $p_m_cercana;
		}else{
			return $domine;
		}

	}
	
	private function country_evaluator($country){

		if (!in_array($domine,$this->cou)){

			$d_m_corta = -1;

			foreach ($this->cou as $p_actual) {

			    $lev = levenshtein($country, $p_actual);

			    if ($lev <= $d_m_corta || $d_m_corta < 0) {
			        $p_m_cercana  = $p_actual;
			        $d_m_corta = $lev;
			    }
			}
			return $p_m_cercana;
		}else{
			return $country;
		}

	}
	
}
?>