<?php
class xlsExport{
	private $table;
	private $con;
	
	public function __construct($table,$con){
		$this->table = $table;
		$this->con = $con;		
	}
	public function export(){
		try {
			$query = "SHOW COLUMNS FROM $this->table";
			$res = $this->con->query($query);
			unset($Fields,$Field,$Type);
			ob_start();
			$this->xlsBOF();	
			$FieldId = 0;
			$Row = 0;
			$Col = 0;
			while($row= $this->con->fetch($res)){
				if($FieldId == 0){
					$FieldId = 1;
				}else{
					$Fields .= "`" . $row["Field"] ."`,";
					$Field[count($Field)] = $row["Field"];
					$Type[count($Type)] = $row["Type"];
					$Value = $row["Field"];
					$this->xlsWriteLabel($Row, $Col, $Value );
					$Col++;
				}
			}
			$Fields = substr($Fields,0,strlen($Fields)-1);
			$sql = "SELECT $Fields FROM `$this->table`;";
			$res = $this->con->query($sql);
			while($row = $this->con->fetch($res)){
				$Row++;
				for($F = 0; $F < count($Field); $F++){
					$Value = $row[$Field[$F]];
					if(ereg("^-?([0-9]+(\.)?[0-9]*$|(\.)[0-9]+$)", $Value)==1){
						$this->xlsWriteNumber($Row, $F, $Value);
					}else{
						$this->xlsWriteLabel($Row, $F, $Value );
					}		
				}		
			}
			$this->xlsEOF();
			$contenido = ob_get_clean();
			$cont=array("$this->table.xls"=>$contenido);
			$this->createzip($cont,"$this->table.zip");
			return "$this->table.zip";
		}catch (Exception $e){
			throw $e;
		}
	}
	private function xlsBOF() {
	    echo pack("ssssss", 0x809, 0x8, 0x0, 0x10, 0x0, 0x0);  
	    return;
	}
	
	private function xlsEOF() {
	    echo pack("ss", 0x0A, 0x00);
	    return;
	}
	
	private function xlsWriteNumber($Row, $Col, $Value) {
	    echo pack("sssss", 0x203, 14, $Row, $Col, 0x0);
	    echo pack("d", $Value);
	    return;
	}
	
	private function xlsWriteLabel($Row, $Col, $Value ) {
	    $L = strlen($Value);
	    echo pack("ssssss", 0x204, 8 + $L, $Row, $Col, 0x0, $L);
	    echo $Value;
	return;
	}
	
	private function createzip($struct,$namezip=0){ 	
		$ZipData = array(); 
		$Dircont = array(); 
		$DirFile = array();
		$offseto = 0;		
		while(list($file,$data)=each($struct))
		{	$file= str_replace("\\", "/", $file);  
		    $dir=explode("/",$file);
			for($i=0; $i<sizeof($dir); $i++)if($dir[$i]=="")unset($dir[$i]);					
			$num=count($dir); //Total de niveles
			$ele=0;  		  //Nivel actual
			$dirname="";	  //Nombre archivo o directorio
			while(list($idx,$val)=each($dir))
			{	$ty=(++$ele)==$num?true:false;
				$ty=trim($data)!=""?$ty:false;//Compruebar si el ultimo elemento es directorio o archivo
				$dirname.=$val.($ty?"":"/");
				if(isset($DirFile[$dirname]))continue; else $DirFile[$dirname]=true;			
				$gzdata="";				
				if($ty)
				{	$unziplen=strlen($data);  
					$czip=crc32($data);  
					$gzdata=gzcompress($data);  
					$gzdata=substr(substr($gzdata,0,strlen($gzdata)-4),2); 
					$cziplen=strlen($gzdata);  
				}						
				$ZipData[]="\x50\x4b\x03\x04".($ty?"\x14":"\x0a")."\x00\x00\x00".($ty?"\x08":"\x00")."\x00\x00\x00\x00\x00".
						   pack("V",$ty?$czip:0).pack("V",$ty?$cziplen:0).pack("V",$ty?$unziplen:0).pack("v",strlen($dirname)). 
						   pack("v",0).$dirname.$gzdata.pack("V",$ty?$czip:0).pack("V",$ty?$cziplen:0).pack("V",$ty?$unziplen:0);
				$Dircont[]="\x50\x4b\x01\x02\x00\x00".($ty?"\x14":"\x0a")."\x00\x00\x00".($ty?"\x08":"\x00")."\x00\x00\x00\x00\x00".
						   pack("V",$ty?$czip:0).pack("V",$ty?$cziplen:0).pack("V",$ty?$unziplen:0).pack("v",strlen($dirname)). 
						   pack("v", 0 ).pack("v",0).pack("v",0).pack("v",0).pack("V",$ty?32:16).pack("V",$offseto).$dirname;  		
				$offseto=strlen(implode("",$ZipData));			
			}//Fin While dir		
		}//Fin While archivos
		$data = implode("",$ZipData);  
		$cdir = implode("",$Dircont);  	
		$data=$data.$cdir."\x50\x4b\x05\x06\x00\x00\x00\x00".pack("v",sizeof($Dircont)).pack("v",sizeof($Dircont)).pack("V",strlen($cdir)).pack("V",strlen($data))."\x00\x00";
	    if($namezip)//Construir el archivo
	    {	if(($fp=fopen($namezip,"wb")))
	   		{	fwrite($fp,$data);
				fclose ($fp);
				return true;
			}else return false;
	    }else return $data;	   
	}
}
?>