<?php	
	include("../jpgraph-2.2/src/jpgraph.php");
	include("../jpgraph-2.2/src/jpgraph_bar.php");
	include ("../jpgraph-2.2/src/jpgraph_line.php"); 
	
	$graphTitle = $_GET['table'];	
	$datay=explode("|",$_GET['arr']);
	$max = max($datay) + (max($datay)/10);
	$xGraph = 400;
	$yGraph = 290;
	if(count($datay)>5){
		$mul = 60 * (count($datay)-5);
		$xGraph = $xGraph + $mul; 
	}

	// Create the graph. These two calls are always required
	$graph = new Graph($xGraph,$yGraph,"auto");	
	$graph->SetScale("textlin",0,$max);
	
	$graph->yaxis->scale->SetGrace(20);
	
	// Setup labels
	$lbl = explode("|",$_GET['lbl']);
	$graph->xaxis->SetTickLabels($lbl);
	
	// Label align for X-axis
	$graph->xaxis->SetLabelAlign('right','center','right');
	$graph->xaxis->SetLabelAngle(10);
	$graph->xaxis->SetLabelMargin(15);
	$graph->xaxis->SetFont(FF_GEORGIA,FS_ITALIC,8);
	
	// Label align for Y-axis
	$graph->yaxis->SetLabelMargin(5);
	
	// Add a drop shadow
	$graph->SetShadow();
	
	// Adjust the margin a bit to make more room for titles
	$graph->img->SetMargin(60,30,10,60);
	$graph->SetMarginColor("#9DC9F2");	
	
	// Setup the titles
	$graph->title->Set($graphTitle);
	$graph->xaxis->SetTitle('Fields','high');
	$graph->yaxis->SetTitle('Total Records','middle'); 	
	$graph->yaxis->SetTitleSide(SIDE_LEFT); 	
	$graph->title->SetFont(FF_FONT1,FS_BOLD);
	$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
	$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
	
	//setup de margin titles
	$graph->yaxis->SetTitleMargin(40);
	$graph->xaxis->SetTitleMargin(25);	
	
	// Create a bar pot
	switch ($_GET['chart']){
		case 'Bar':
			$bplot = new BarPlot($datay);
			
			// Setup color for gradient fill style 
			$bplot->SetFillGradient("navy","lightsteelblue",GRAD_VER);
			// Set color for the frame of each bar
			$bplot->SetColor("navy");
			
			// Adjust fill color	
			$bplot->SetWidth(0.75);
			$bplot->SetShadow();
			$bplot->value->Show();
			$bplot->value->SetFont(FF_ARIAL,FS_BOLD,10);
			$bplot->value->SetAngle(45);	
			$graph->Add($bplot);			
			break;
		case 'Line':
			$lineplot = new LinePlot($datay);
			$lineplot->mark->SetType(MARK_UTRIANGLE);			
			$lineplot->value->show();			
			// Add the plot to the graph
			$graph->Add($lineplot);
			
			$lineplot->SetColor("blue");
			$lineplot->SetWeight(2);
			break;
		default:
			break;
	}
	// Display the graph
	$graph->Stroke();
?>