Ext.grid.Grid.prototype.AddQuickSearch = function(toolbar) {	
	toolbar.addSeparator();
	cm = this.getColumnModel();
	internaldataSource = this.dataSource;
	internaldataSource.myfilter = '';
	var quickMenuItems = [];
	quickMenuItems.push('<b class="menu-title">Quicksearch Columns</b>');
	for(i=0; i < cm.getColumnCount() ; i++){
		quickMenuItems.push(new Ext.menu.CheckItem({ renderer: cm.getRenderer(i), text: cm.getColumnHeader(i), store: cm.getDataIndex(i), checked: true }))
		// time to load our renderers to the columnmodles
		cm.setRenderer(i, renderStub);
	}

    var quickMenu = new Ext.menu.Menu({
	id: 'quickMenu',
	items: quickMenuItems
    });
    toolbar.add({
	text: 'Quicksearch',
	tooltip: 'Quickly search through the current page.',
	icon: '/admin/include/m.png',
	cls: 'x-btn-text-icon btn-search-icon',
	menu: quickMenu
    });
    var sftb = toolbar.addDom({
	tag: 'input',
	id: 'quicksearch',
	type: 'text',
	size: 30,
	value: '',
	style: 'background: #F0F0F9;',
	emptyText: "Type to quicksearch",
    });

    var searchRec = Ext.data.Record.create([
        {name: 'query', type: 'string'}
    ]);
    var onFilteringBeforeQuery = function(e) {
	//grid.getSelectionModel().clearSelections();
	internaldataSource.myfilter = e;
	var value = Ext.get('quicksearch').getValue();
	if (value.length==0) {
		internaldataSource.clearFilter();
	} else {
		value = value.replace(/^\s+|\s+$/g, "");
		if (value=="")
			return;
		internaldataSource.filterBy(function(r) {
		// filter operator AND on all keywords for defined columns
			valueArr = value.split(/\ +/);
			for (var j=0; j<valueArr.length; j++) {
				re = new RegExp(Ext.escapeRe(valueArr[j]), "i");
				keep = false;
				for (var i=0,items=quickMenuItems,len=items.length; i<len; i++){
					if (items[i].checked) {
						if(items[i].renderer && renderStub)	{
							var afterrder = items[i].renderer(r.data[items[i].store.toLowerCase()]);
							if(re.test(afterrder) == true)
								return true;
						}
						if (re.test(r.data[items[i].store.toLowerCase()])==true){
							keep = true;
						}
					}
				}
				if (!keep){
					return false;
				}
			}
		return true;
		});
	}
	};

    function renderStub(value, p, record, rowIndex, ind , ds){
    	var stubval = value;
    	var offset = ind+1;
    	if(quickMenuItems[offset].renderer) { // we already have a renderer then call it first
    		stubval = quickMenuItems[offset].renderer(value, p, record, rowIndex, ind , ds);
    	}
    	return renderFoundAll(stubval, p, record, rowIndex, ind , ds);
    }
    
    function renderFoundAll(value, p, record, rowIndex, ind , ds){		
    	if (ds.myfilter !=''){			
	        foundArray = new Array();
	        result = null;
	        a = 1;
	        start = 0;
	        while(result >=0){
        		result = value.toLowerCase().indexOf(ds.myfilter.toLowerCase(),start);
        		foundArray[foundArray.length] = result;
        		a=a+1;
        		start = result+1;
			}
	        var tmpString = value.substr(0,ds.myfilter.length);
	        index = 0;
	        i = 0;
	        construct = '';
	        while (i<foundArray.length){
		        if (foundArray[i]>index){
        			construct = construct + String.format('{0}<span style="color:red; font-weight: bold;">{1}</span>', value.substring(index,foundArray[i]), ds.myfilter);
				}else if(foundArray[i]==index){
        			construct = construct + String.format('<span style="color:red; font-weight: bold;">{0}</span>', ds.myfilter);
				}else if(foundArray[i]==-1){
		          	construct = construct + String.format('{0}', value.substring(index,value.length-foundArray[i]-1));
				}
	        index = index + value.substring(index,foundArray[i]).length+ ds.myfilter.length;
	        i=i+1;
			}
	        if ((foundArray.length-1)>0){
        		return construct;
			}else{
         		return value;
			}

	    }else{
	    	return value;
		}
	}
  /*  quickMenu.on('click', onFilteringBeforeQuery);
    sftb.on("change", function(){alert('its in');});//onFilteringBeforeQuery*/
		Ext.get('quicksearch').on("keydown", onFilteringBeforeQuery);

};