<?php
class Select{
	private $cont=0;
	private $values;
	private $labels;
	private $selectedValue=NULL;
	private $selectedPos=NULL;
	private $id;
	private $class;
	private $style;
	
	public function __construct(){
		$this->id = $id;
		$this->class = $class;
		$this->style = $style;
	}
	
	public function agregarOpcionesSQL($query, $con){
		try{
			$res = $con->query($query);
			while($fila = $con->fetch($res)){
				$value = $fila[0];
				$label = $fila[1];
				$this->agregarOpcion($value, $label, '');
			}

		}catch(Exception $e){
			throw new Exception("La sentencia SQL no es valida");
		}
	}
	
	public function agregarOpcion($value, $label){
		$this->values[$this->cont]=$value;
		$this->labels[$this->cont]=$label;
		if($selected!=''){
			$this->$selected=$value;
		}
		$this->cont++;
	}
	
	public function agregarObjeto($obj){
		$this->values[$this->cont]=$obj->getKey();
		$this->labels[$this->cont]=$obj->getLabel();
		if($selected!=''){
			$this->$selected=$value;
		}
		$this->cont++;
	}
	
	public function agregarObjetos($arr){
		foreach($arr as $obj){
			$this->agregarObjeto($obj);
		}
	}
	
	public function removerOpciones(){
		unset ($this->values);
		unset ($this->labels);
		$this->cont = 0;
		$this->selectedValue=NULL;
		$this->selectedIndex=NULL;
	}
	
	public function seleccionarValue($value){
		$this->selectedValue = $value;
		$this->selectedPos = NULL;
	}	

	public function seleccionarIndex($pos){
		$this->selectedPos = $pos;
		$this->selectedValue = NULL;
	}
	
	public function getHTML(){
		$x=0;
		if(count($this->values) != 0){
			foreach($this->values as $value){
				if(($value==$this->selectedValue&&$this->selectedValue!=NULL)||($this->selectedPos==$x&&$this->selectedPos!=NULL)){
					$html.="<option selected='selected' value = '$value'>".$this->labels[$x]."</option>\n";
				}else{
					$html.="<option value = '$value'>".$this->labels[$x]."</option>\n";	
				}
				$x++;
			}
		}
		return $html;
	}
	
	public function getJavaScript($id){
		$java.="var sel = document.getElementById('".$id."'); ";
		$java.="sel.options.length = 0; ";
		$x=0;
		if(count($this->values) != 0){
			foreach($this->values as $value){
				$label = $this->labels[$x];
				$java.="sel.options[sel.options.length] = new Option('".$label."','".$value."');";
				if(($value==$this->selectedValue&&$this->selectedValue!=NULL)||($this->selectedPos==$x&&$this->selectedPos!=NULL)){
					$java.="sel.options[$x].selected = true;";
				}
				$x++;
			}		
		}
//		echo $java;
		return $java;
	}
	
	public function getCont(){
		return cont;
	}
}
?>