<?php
class AlgDialog{

	private $param_desc;
	private $alg_title;
	private $js_dlg;
	
	public function __construct($contentSize,$moveTo,$div){
		$this->js_dlg = "
		dialog_cct = new Ext.LayoutDialog('$div', {
			modal:true,
			shadow:true,
			proxyDrag: true,
			collapsible: false,
			resizable: false,
			//closable: false,	
			center: { 
				autoScroll:true,
				tabPosition: 'top',
				closeOnTab: true,
				alwaysShowTabs: true
			}
		});
		//dialog_cct.addKeyListener(27, dialog_cct.hide, dialog_cct);		
		dialog_cct.show();
		dialog_cct.setContentSize($contentSize);
		dialog_cct.moveTo($moveTo);
		var layout = dialog_cct.getLayout();
		layout.beginUpdate();
		layout.add('center', new Ext.ContentPanel('table_cont_div', {title: 'Algorithm', closable: false}));
		layout.add('center', new Ext.ContentPanel('table_help_div', {title: 'Help', closable: false}));		
		layout.getRegion('center').showPanel('table_cont_div');
		layout.endUpdate();		
		";
	}
	public function getDLG(){
		return $this->js_dlg;
	}
	
	/**
	 * Return html string with the html structure to create the dialog and the form
	 * 
	 *
	 *@param string contains the title for the dialog
	 * 
	 *@return html string, use with xajax --> $xajax->assign('target','innerHTML',this)
	 *	 
	 */
	
	public function getFormStruct($title,$width,$msg,$nonprintable = "no"){
		$this->alg_title = $title;
		ob_start();
		?>	
		<div class="x-dlg-hd" ><?php echo $title;?></div>	
		<div class="x-dlg-bd">
			<div id="table_cont_div">
				<div class="x-dlg-tab">
					<div class="inner-tab">
					<div class="x-AlgorithmForm"><?php echo $msg; ?></div>
					<div>
						<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
							<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc">      
								<div id="description_alg">					
								</div>
								<?php if($nonprintable == "yes"){ 
									echo "<div id='table_alg1' style='border:1px solid #99bbe8;overflow: hidden; width:".$width."px; height: 200px;'></div><br>";
									$height = "200";
								}else{
									$height = "350";
								}?>
								<div id='table_alg' style='border:1px solid #99bbe8;overflow: hidden; width:<?php echo $width; ?>px; height: <?php echo $height; ?>px;'></div>
								<br><div id="formulario"></div>
							</div></div></div>
							<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
						</div>
					</div>
				</div>
			</div>
			<div id="table_help_div">
			
			</div>
		</div>
		<?php
		return ob_get_clean();
	}
		public function getHtmlHelpT($Description, $Example){
		$HTMLhelp = $this->setHtmlHelpT($Description,$Example);
		return  $HTMLhelp;		
	}
	
	private function setHtmlHelpT($Description, $Example){
		$xy = explode(",",$this->contentSize);
		$h_c_width = "100%";
		$h_c_height = "100%";
		ob_start();
		?>
		<table width="<?php echo $h_c_width; ?>px;" height="<?php echo $h_c_height; ?>px" bgcolor="#E6E6CC">
		<tr>
			<td class="help-heads">
				Description
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->alg_title . " : " . $Description;  ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Parameters
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->param_desc; ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Example
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $Example;  ?>
			</td>
		</tr>
		</table>		
		
		<?php
		return ob_get_clean();
	}
	
	public function setDescription($desc){
		$this->param_desc .= $desc;
	}	
}
?>