<?php
/**
 * 
 * @package algorithmform
 */
class FormatForm{
	private $contentSize;
	private $moveTo;	
	private $js_dlg;
	private $dlg_form;
	private $boxes;
	private $FieldResume;
	private $csvForm;	
	private $TableResume;
	private $form;
	private $table_name;
	private $decimalSymbol;
	private $radioCSV;
	private $textQualifier;
	private $exec_func;
	private $param_desc;
	private $alg_title;
	private $FR;
	/**a
	 * Create a new dialog box for the form
	 * 
	 *
	 *@param string contains the Content Size values --> 'width,height'
	 *@param string the position of the dialog box	 --> 'x,y'
	 *@param string the extension of the file used .csv , .xls
	 *@param number the id of kind of form to create --> 1= CSV Upload, 2= XLS Upload, 3=CSV Export
	 */
	public function __construct($contentSize,$moveTo,$ext,$FR){
		$this->contentSize = $contentSize;
		$this->FieldResume = '';
		$this->TableResume = '';
		$this->decimalSymbol = '';
		$this->FR = $FR;
		$this->js_dlg = "
		dialog = new Ext.LayoutDialog('algorithm-dlg', {
			modal:true,
			shadow:true,
			proxyDrag: true,
			collapsible: false,
			closable: false,
			resizable: false,
			center: { 
				autoScroll:true,
				tabPosition: 'top',
				closeOnTab: true,
				alwaysShowTabs: true
			}
		});";
		//id the form will bo to export, enable keylistener, else if the form is to uload disabled
		if($FR == 3){
			$this->js_dlg.= "
			//dialog.addKeyListener(27, killDialog, dialog);";
		}
		$this->js_dlg.="		
		dialog.show();
		dialog.setContentSize($contentSize);
		dialog.moveTo($moveTo);
		function killDialog(){
			dialog.hide();
			dialog.destroy();
		}
		var layout = dialog.getLayout();
		layout.beginUpdate();
		layout.add('center', new Ext.ContentPanel('format_content', {title: 'Algorithm', closable: false}));
		layout.add('center', new Ext.ContentPanel('format_help', {title: 'Help', closable: false}));		
		layout.getRegion('center').showPanel('format_content');
		layout.endUpdate();		
		
		
		";
		//if form is to upload fr = true, else is to export
		switch ($FR){
			case 1:
				$this->exec_func = "xajax_resumen(xajax.getFormValues('form'));";
				break;
			case 2:
				$this->exec_func = "xajax_XLSresumen(xajax.getFormValues('form'));";
				break;
			case 3:
				$this->exec_func = "xajax_verifyCSV(xajax.getFormValues('form'),'$this->table_name',1);";
				break;
		}
		switch ($ext){
			case ".csv":
				$this->setRadioCsv();
				$this->setTextQualifier();
				if($FR == 1){					
					$this->setFieldResume();
					$this->setTableResume();
				}elseif ($FR == 3){					
					$this->setDecimalSymbol();
				}
				$this->setForm();
				break;
			case ".xls":
				$this->setFieldResume();
				$this->setTableResume();
				$this->setForm();				
				break;
			default:
				break;							
		}
		
	}
	/**
	 * Create a new combo box for the form
	 * 
	 *
	 *@param string contains the Id of the combo box it must be unique
	 *@param string the label for the combo box
	 *@param string the id and name of the options in the combo box --> "'id','column_name'"
	 *@param string the options who have the combo box  --> "['id','name'], ['id','name'] ..."
	 *@param string the text to show when the combo box is empty
	 *@param string the option who will be show  
	 */
	
	private function setForm(){	
		ob_start();
		?>
	<table border="0" cellpadding="3px" cellspacing="3px" class="x-csvform">
	<tr>
	<td width="49%">
		<form id="form" name="form">
		<?php echo $this->radioCSV; ?>
	<br><br>
	<fieldset class="x-fieldset"> 
	<table width="100%" class="x-csvform" style="vertical-align:middle">
		<tr>
			<td> <input type="checkbox" id="cab" name="cab" value="1" onClick="<?php echo $this->exec_func; ?>"> <label for="cab">First Row Contains Column Names</label>
			</td>
			<?php echo $this->textQualifier; ?>			
		</tr>
	</table>
	</fieldset>
	<br>
	<?php echo $this->decimalSymbol; ?>
	<br>
	<fieldset class="x-fieldset">
		<legend> Date Format, Date Delimiter, Time Delimiter</legend>
		<table class="x-csvform" style="vertical-align:middle">
			<tr>
				<td colspan="2">
					Format:
					<select id="t_fecha" name="t_fecha" onchange="<?php echo $this->exec_func; ?>">
					<?php
						if($this->FR == 1 || $this->FR == 2){
							echo "
							<option value='012'>YMD</option>
							<option value='021'>YDM</option>
							<option value='210'>DMY</option>
							<option value='120'>DYM</option>
							<option value='102'>MYD</option>
							<option value='201'>MDY</option>
							";
						}else{
							echo "
							<option value='012'>YMD</option>
							<option value='021'>YDM</option>
							<option value='210'>DMY</option>
							<option value='201'>DYM</option>
							<option value='102'>MYD</option>
							<option value='120'>MDY</option>
							";
						}
					?>
					</select>
					&nbsp;&nbsp;&nbsp;
					Delimiter:
					<input type="text" id="d_fecha" name="d_fecha" value="/" maxlength="1" size="1" onKeyUp="<?php echo $this->exec_func; ?>">
					&nbsp;&nbsp;&nbsp;
					Time :
					<input type="text" id="d_tiempo" name="d_tiempo" value=":" maxlength="1" size="1" onKeyUp="<?php echo $this->exec_func; ?>">
				</td>
			</tr>
		</table>
	</fieldset>
	<br>
	<?php echo $this->TableResume; ?>
	</form>
	</td>
	<?php echo $this->FieldResume; ?>
	</tr>
	</table>	
	<?php
	$this->form = ob_get_clean();
	}
	
	public function getForm(){
		return $this->form;
	}
	private function setRadioCsv(){
		ob_start();
		?>
		<fieldset class="x-fieldset">
		<legend>Field Delimiter</legend>
		<table width="100%" class="x-csvform">
		<tr>
			<td>
				<label for="sep0">Comma&nbsp;</label> <input type="radio" id="sep0" name="sep" value="," checked="checked" onClick="get('o_sep').disabled=true; <?php echo $this->exec_func; ?>">
			</td>
			<td>
				<label for="sep1">Semicolon&nbsp;</label><input type="radio" id="sep1" name="sep" value=";" onClick="get('o_sep').disabled=true; <?php echo $this->exec_func; ?>">
			</td>
			<td>
				<label for="sep2">Tab&nbsp;</label><input type="radio" id="sep2" name="sep" value="t" onClick="get('o_sep').disabled=true; <?php echo $this->exec_func; ?>">
			</td>
			<td>
				<label for="sep3">Space&nbsp;</label><input type="radio" id="sep3" name="sep" value=" " onClick="get('o_sep').disabled=true; <?php echo $this->exec_func; ?>">
			</td>
			<td>
				<label for="sep4">Other&nbsp;</label><input type="radio" id="sep4" name="sep" value="-" onClick="get('o_sep').disabled=false; get('o_sep').focus();">
				<input type="text" maxlength="1" size="1" id="o_sep" name="o_sep" disabled="disabled" onKeyUp="<?php echo $this->exec_func; ?>">
			</td>	
		</tr>
		</table>	
		</fieldset>		
		<?php
		$this->radioCSV = ob_get_clean();
	}
	private function setTextQualifier(){
		ob_start();
		?>
		<td>
			Text Qualifier
			<select name="cad" id="cad" onChange="<?php echo $this->exec_func; ?>">				
				<option value="2" selected="selected">"</option>
				<option value="1">'</option>
			</select>
		</td>
		<?php
		$this->textQualifier = ob_get_clean();
	}
	private function setDecimalSymbol(){
		ob_start();
		?>
		<fieldset class="x-fieldset">
		<legend>Decimal Symbol</legend>
		<table width="50%" class="x-csvform" style="vertical-align:middle">
			<tr>
				<td>			
					Dot <input type="radio" id="num" name="num" value="." checked="checked" onClick="<?php echo $this->exec_func; ?>">
				</td>
				<td>
					Comma <input type="radio" id="num" name="num" value="," onClick="<?php echo $this->exec_func; ?>">
				</td>
			</tr>
		</table>
		</fieldset>		
		<?php
		$this->decimalSymbol = ob_get_clean();
	}
	private function setTableResume(){
		ob_start();
		?>
		<br>
		<div id="tableresume"  style="width:400px;height:270px;">
		<div id="tabladedatos"></div></div>
		<br>
		<?php
		$this->TableResume = ob_get_clean();
	}
	private function setFieldResume(){
		ob_start();
		?>
		<td width="49%" style=" vertical-align:top">
		<div id="fieldselect"></div>
		<table>
			<tr>
				<td>
					<fieldset>
						<legend> Field Types </legend>
						<div class="csvFieldResume" id="TypeText" style="width:330px;height:190px;"></div>
					</fieldset>				
					</td>			
				</tr>
			</table>						
		</td>
		<?php
		$this->FieldResume = ob_get_clean();
	}
	public function setCSVExportTable($table){
		$this->table_name = $table;
	}
	public function setCSVForm($div,$btnName,$btn){
		$this->csvForm = "
		var csvForm = new Ext.form.Form({
		labelWidth: 100
		});
		$btnName = csvForm.addButton({
			text: ' Export ',
			id: '$btnName',
			disabled: false,
			handler: function(){
				dialog.hide(); dialog.destroy(); Ext.MessageBox.wait('Exporting Data', 'Please Wait');
				xajax_verifyCSV(xajax.getFormValues('form'),'$this->table_name',$btn);
			}
		});
		csvForm.addButton({
			text: 'Cancel',
			handler: function(){
				dialog.hide();
				dialog.destroy();
			}
		});
		csvForm.render('$div');		
		";
		return $this->csvForm;
	}
	/**
	 * Return js string with the dialog box
	 * 
	 *@return js string, the dialog box
	 *	 
	 */
	
	public function getJS(){
		return $this->js_dlg;			
	}
	/**
	 * Return html string with the html structure to create the dialog and the form
	 * 
	 *
	 *@param string contains the title for the dialog
	 * 
	 *@return html string, use with xajax --> $xajax->assign('target','innerHTML',this)
	 *	 
	 */
	
	public function getFormStruct($title,$msg){
		$this->alg_title = $title;
		ob_start();
		?>	
		<div class="x-dlg-hd" ><?php echo $title;?></div>	
		<div class="x-dlg-bd">
			<div id="format_content">
			<div class="x-dlg-tab">
				<div class="inner-tab">
				<div class="x-AlgorithmForm"><?php echo $msg; ?></div>
				<div>
					<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
						<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc">
									<div id="disc_div">				
									</div>								
						</div></div></div>
						<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
					</div>
				</div>
			</div>
			</div>
			<div id="format_help"></div>
		</div>
		<?php
		return ob_get_clean();
	}
	public function getHtmlHelpF($Description, $Example){
		$HTMLhelp = $this->setHtmlHelpF($Description,$Example);
		return  $HTMLhelp;		
	}
	public function setParam_desc($desc){
		$this->param_desc = $desc;
	}
	private function setHtmlHelpF($Description, $Example){
		$xy = explode(",",$this->contentSize);
		/*$h_c_width = $xy[0]- 5;
		$h_c_height = $xy[1] - 30;*/
		$h_c_width = "100%";
		$h_c_height = "100%";
		ob_start();
//#CCCC99		
		?>
		<table width="<?php echo $h_c_width; ?>px;" height="<?php echo $h_c_height; ?>px" bgcolor="#E6E6CC">
		<tr>
			<td class="help-heads">
				Description
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->alg_title . " : " . $Description;  ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Parameters
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->param_desc; ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Example
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $Example;  ?>
			</td>
		</tr>
		</table>		
		
		<?php
		return ob_get_clean();
	}
}
?>