<?php
/**
 * 
 * @package algorithmform
 */
class algorithmForm{
	private $contentSize;
	private $moveTo;
	private $js_dlg;
	private $dlg_form;
	private $boxes;
	private $upload_form;
	private $help_cont;
	private $param_desc;
	private $alg_title;
	private $msgDiv;
	private $formWidth;
	private $listeners;
	private $needColumnBtn;
	private $id_cont;
	private $id_help;
	private $id_form;
	private $id_errormsg;
	private $cancelFunc;
	private $dialogName;
	private $comboEvent;
	
	private $combocolumnscont;

	/**
	 * Create a new dialog box for the form
	 * 
	 *
	 *@param string contains the Content Size values --> 'width,height'
	 *@param string the position of the dialog box	 --> 'x,y'
	 */
	public function __construct($contentSize,$moveTo,$div,$id_cont = 'cont_div',$id_help = 'help_div',$id_form = 'disc_div', $id_errormsg = 'msgDiv', $dialogName = 'dialog'){
		$this->comboEvent = '';
		$this->dialogName = $dialogName;
		$this->id_form = $id_form;
		$this->id_errormsg = $id_errormsg;
		$this->id_cont = $id_cont;
		$this->id_help = $id_help;
		$this->needColumnBtn = 'no';
		$this->listeners = '';
		$this->msgDiv = '';
		$this->contentSize = $contentSize;
		$this->moveTo = $moveTo;
		$this->param_desc = '';
		$this->formWidth = 0;
		$this->js_dlg = "
		Ext.QuickTips.init();
	    // turn on validation errors beside the field globally
    	Ext.form.Field.prototype.msgTarget = 'side';
		/*if(layoutIsOpen == true){
			$this->dialogName.hide();
			$this->dialogName.destroy();
		}*/
		layoutIsOpen = true;
		$this->dialogName = new Ext.LayoutDialog('$div', {
			modal:true,
			shadow:true,
			proxyDrag: true,
			collapsible: false,
			resizable: false,
			//closable: false,	
			center: { 
				autoScroll:true,
				tabPosition: 'top',
				closeOnTab: true,
				alwaysShowTabs: true
			}
		});
		//$this->dialogName.addKeyListener(27, $this->dialogName.hide, $this->dialogName);
		$this->dialogName.show();
		$this->dialogName.setContentSize($contentSize);
		$this->dialogName.moveTo($moveTo);

		var layout = $this->dialogName.getLayout();
		layout.beginUpdate();
		layout.add('center', new Ext.ContentPanel('$id_cont', {title: 'Algorithm', closable: false}));
		layout.add('center', new Ext.ContentPanel('$id_help', {title: 'Help', closable: false}));		
		layout.getRegion('center').showPanel('$id_cont');
		layout.endUpdate();
		";
		
	}
	
	public function resizeDialog($contentSize){
		$this->boxes .= "$this->dialogName.setContentSize($contentSize);";
	}
	/**
	 * Create a new combo box for the form
	 * 
	 *
	 *@param string contains the Id of the combo box it must be unique
	 *@param string the label for the combo box
	 *@param string the id and name of the options in the combo box --> "'id','column_name'"
	 *@param string the options who have the combo box  --> "['id','name'], ['id','name'] ..."
	 *@param string the text to show when the combo box is empty
	 *@param string the option who will be show  
	 */
	public function addCombo($id, $label, $fieldNames, $fields, $emptyText, $displayField, $description){
		$this->param_desc .= $description . '<br>';
		$store = $id ."_store";
		$rec = $id ."_rec";
		$fds = explode(",",$fieldNames);
		//$store.add(new $rec({ ".$fds[0] .": '__field1__', ".$fds[1].": 'field1 varchar(255)' }));
		$this->boxes .= "
		$rec = Ext.data.Record.create( [
			{name: ".$fds[0] .", type: 'string'},
			{name: ".$fds[1] .", type: 'string'}
		]);		
		
		$store = new Ext.data.SimpleStore({
					fields: [$fieldNames],
					data : [$fields]
				});
		
		alg_Form.add(
			new Ext.form.ComboBox({
				fieldLabel: '$label',				
				name : '$id',
				id: '$id',
				store: $store,
				displayField:'$displayField',
				typeAhead: true,				
				mode: 'local',
				triggerAction: 'all',
				emptyText:'$emptyText',
				selectOnFocus:true,
				width:180,
				allowBlank:false,
				editable:false
			})
		);
		";	
	}
	public function setComboColumnStore($id,$fieldNames,$fields){
		$store = $id ."_store";
		$rec = $id ."_rec";
		$fds = explode(",",$fieldNames);
		//$store.add(new $rec({ ".$fds[0] .": '__field1__', ".$fds[1].": 'field1 varchar(255)' }));
		$this->boxes .= "
		var $rec = Ext.data.Record.create( [
			{name: ".$fds[0] .", type: 'string'},
			{name: ".$fds[1] .", type: 'string'}
		]);		
		
		var $store = new Ext.data.SimpleStore({
					fields: [$fieldNames],
					data : $fields
				});";
	}
	public function setComboColumnCont($id,$label,$displayField,$emptyText,$value = "null"){
		$store = $id ."_store";
		$this->combocolumnscont .= "
		new Ext.form.ComboBox({
			fieldLabel: '$label',				
			name : '$id',
			id: '$id',
			store: $store,
			displayField:'$displayField',
			typeAhead: true,				
			mode: 'local',
			triggerAction: 'all',
			emptyText:'$emptyText',
			selectOnFocus:true,
			width:80,
			allowBlank:false,
			editable:false";		
		if($value != 'null'){
			$this->combocolumnscont .=",value: '$value'}),";
		}else {
		$this->combocolumnscont .="}),";	
		}
		
	}
	public function setTextFieldColumn($id, $label, $regExp, $regexText, $allowBlank, $valueIn, $invalidText, $beforeext, $afterext, $description){
		$this->param_desc .= $description . '<br>';		
		$this->combocolumnscont .= "
		new Ext.form.TextField({
			fieldLabel: '$label',
			name: '$id',
			id:'$id',
			width:160,
			allowBlank:$allowBlank,				
			regex: $regExp,
			regexText: '$regexText'				
		";
		if($valueIn == ''){
			$this->combocolumnscont .= "
				}),";
		}else{
			$this->combocolumnscont .= ",
					invalidText: '$invalidText',
					validator: function(value){
						value = '$beforeext' + value + '$afterext';
						var txt = '$valueIn';
						txt = txt.split('&&&');
						var ban = 1;
						for(var i=0; i<txt.length; i++){
							if(value.toLowerCase() == txt[i]){							
								ban = 0;
								break;
							}else{
								ban = 1;
							}
						}
						if(ban == 0){
							return false;
						}else{
							return true;
						}
					}
				}),";			
		}			
	}
	public function setColumn($hideLabels = 'false',$width = '215'){		
		$this->combocolumnscont = substr($this->combocolumnscont,0,strlen($this->combocolumnscont)-1);		
		$this->boxes .="		
		alg_Form.column(
			{labelAlign: 'right', width: $width, hideLabels: $hideLabels},
			$this->combocolumnscont
			";
		$this->boxes = substr($this->boxes,0,strlen($this->boxes)-1);
		$this->boxes .= ");";
	}
	public function freeColumn(){
		unset($this->combocolumnscont);
	}
	/**
	 * Create a new number field for the form
	 * 
	 *
	 *@param string contains the Id of the number field it must be unique
	 *@param string the label for the number field
	 *@param number default value for the number field
	 *@param string the regular expression to evaluate in this number field (posix) ex. "/^\d+$/"
	 *@param string the text to show if regular expression evaluation fails
	 *@param string true/false to allow blank
	 *@param string evaluate the value of the number field with the given string
	 *@param string the text to show if the value of the number field not match with the value given by $valueIn
	 */
	public function addNumberField($id, $label, $default, $regExp, $regexText, $allowBlank, $allowDec, $valueIn, $invalidText, $description){
		$this->param_desc .= $description . '<br>';
		$this->boxes .= "
		alg_Form.add(
			new Ext.form.NumberField({
				fieldLabel: '$label',
				name: '$id',
				id:'$id',
				width:175,
				allowBlank:$allowBlank,
				allowDecimals:$allowDec,
				regex: $regExp,
				regexText: '$regexText', 
				value: $default				
		";
		if($valueIn == ''){
			$this->boxes .= "
				})
			);
			";
			
		}else{
			$this->boxes .= ",
					invalidText: '$invalidText',
					validator: function(value){
						if(value.search(/$valueIn/) == -1){
							return false;
						}else{
							return true;
						}
					}
				})
			);
			";			
		}	
	}
	/**
	 * Create a new text field for the form
	 * 
	 *
	 *@param string contains the Id of the text field it must be unique
	 *@param string the label for the text field
	 *@param string the regular expression to evaluate in this text field (posix) ex. "/^\d+$/"
	 *@param string the text to show if regular expression evaluation fails
	 *@param string true/false to allow blank
	 *@param string evaluate the value of the text field with the given string
	 *@param string the text to show if the value of the text field not match with the value given by $valueIn
	 *@param string used for input files...
	 */
	public function addTextField($id, $label, $regExp, $regexText, $allowBlank, $valueIn, $invalidText, $beforeext, $afterext, $description,$length){
		$this->param_desc .= $description . '<br>';
		$this->boxes .= "
		alg_Form.add(
			new Ext.form.TextField({
				fieldLabel: '$label',
				name: '$id',
				id:'$id',
				width:175,
				allowBlank:$allowBlank,				
				regex: $regExp,
				regexText: '$regexText',
				maxLength: $length
		";
		if($valueIn == ''){
			$this->boxes .= "
				})
			);
			";
			
		}else{
			$this->boxes .= ",
					invalidText: '$invalidText',
					validator: function(value){
						value = '$beforeext' + value + '$afterext';
						var txt = '$valueIn';
						txt = txt.split('&&&');
						var ban = 1;
						for(var i=0; i<txt.length; i++){
							if(value.toLowerCase() == txt[i].toLowerCase()){							
								ban = 0;
								break;
							}else{
								ban = 1;
							}
						}
						if(ban == 0){
							return false;
						}else{
							return true;
						}
					}
				})
			);
			";			
		}	
	}	
	
	public function addListener($id){
		$this->listeners = "		
		alg_Form.items.get('$id').on('beforequery',function(){
			alert('listener added');
		});
		";
	}
	public function addEditor($id,$label,$width, $height,$description){
		$this->param_desc .= $description . '<br>';
		$this->boxes .= "
		alg_Form.container({labelAlign: 'top'},		
			new Ext.form.TextArea({
				id:'$id',
				fieldLabel:'$label',
				width:$width,
				height:$height				
			})
		);
		";
	}
	function addMultiselect($name, $fromLabel, $toLabel, $dataFields, $fromData,$toData, $width, $height, $valueField, $displayField, $fieldLabel,$hideLabel,$description){
		$this->param_desc .= $description . '<br>';
		$this->boxes.="
		var itemSelector = new Ext.ux.ItemSelector({
			name: '$name', 
			dataFields:$dataFields, 
			fromData:$fromData,
			toData:$toData,
			msWidth: $width,
			msHeight: $height,
			valueField: '$valueField',
			displayField: '$displayField',
			fieldLabel: '$fieldLabel',
			fromLabel: '$fromLabel',
			toLabel: '$toLabel'
		});
		alg_Form.container({labelAlign: 'top',hideLabels:$hideLabel},
		itemSelector);
		";
	}
	public function addMsgDiv($id,$html){
		$this->msgDiv .="
		var msg = Ext.get('$id');
		msg.createChild({
			tag:'div',
			html:'<br>$html'
		});
		";
	}
	public function setContainer($id){
		$this->boxes .= "alg_Form.container({id: '$id'}); alg_Form.end();";
	}
	public function addColumnButton(){
		$this->needColumnBtn = 'yes';
		$this->boxes .= "
		alg_Form.column({id:'buttonFly',labelAlign: 'top',width: 100});		
		";
	}
	/**
	 * Sets a combo event between two comboboxes, this function only apply
	 * in Change Column Type filter
	 * 
	 *
	 *@param string contains the Id of the base combo_box
	 *@param string contains the Id of the destiny combo_box
	 *@param string th ids of the combo box "'id','column_name'"
	 */
	
	public function ComboEvent($combo_base, $combo_dest,$carac){
		$fs = str_replace("'","",$fs);
		$fs = explode(",",$carac);
		$store = $combo_dest."_store";
		$rec = $combo_dest ."_rec";
		$this->comboEvent = "
		alg_Form.findField('$combo_base').on('select',function(combo,record,index){			
			var value = combo.getValue().split(' ');
			if(value[1] == 'varchar(255)'){
				alg_Form.findField('$combo_dest').clearValue();
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'double', ". $fs[1] . ": 'double'}));
				$store.add(new $rec( { ". $fs[0] .": 'int(11)', ". $fs[1] . ": 'int(11)'}));
				$store.add(new $rec( { ". $fs[0] .": 'date', ". $fs[1] . ": 'date'}));
				$store.add(new $rec( { ". $fs[0] .": 'datetime', ". $fs[1] . ": 'datetime'}));
				$store.add(new $rec( { ". $fs[0] .": 'time', ". $fs[1] . ": 'time'}));
			}else if(value[1] == 'double'){
				alg_Form.findField('$combo_dest').clearValue();
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'varchar(255)', ". $fs[1] . ": 'varchar(255)'}));
				//$store.remove($store.getAt(index+1));
			}else if(value[1] == 'int(11)'){
				alg_Form.findField('$combo_dest').clearValue();
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'varchar(255)', ". $fs[1] . ": 'varchar(255)'}));
			}else if(value[1] == 'date'){
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'varchar(255)', ". $fs[1] . ": 'varchar(255)'}));				
			}else if(value[1] == 'datetime'){
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'varchar(255)', ". $fs[1] . ": 'varchar(255)'}));				
			}else if(value[1] == 'time'){
				$store.removeAll();
				$store.add(new $rec( { ". $fs[0] .": 'varchar(255)', ". $fs[1] . ": 'varchar(255)'}));				
			}
		});";
	}		

	/**
	 * Create a new radio button for the form
	 * 
	 *
	 *@param string contains the Id of the text field it must be unique
	 *@param string the label for the text field
	 *@param string the regular expression to evaluate in this text field (posix) ex. "/^\d+$/"
	 *@param string the text to show if regular expression evaluation fails
	 *@param string true/false to allow blank
	 *@param string evaluate the value of the text field with the given string
	 *@param string the text to show if the value of the text field not match with the value given by $valueIn
	 *@param string used for input files...
	 */
	public function getUploadForm($label,$id){
		$this->param_desc .= "FileUpload Textfield: String<br>";
		$this->upload_form ="
		upForm = new Ext.form.Form({
				labelWidth: 20,
				labelAlign: 'right',
				name: 'uploadForm',
				fileUpload : true,
				method: 'POST',
				url:'../Carga/writeFile.php',
				baseParams: { action : 'upload', 'preloadid' : '$id' }
		});
		upForm.add(
			new Ext.form.TextField({
				fieldLabel: '$label',
				name: 'fileUpload',
				id: 'fileUpload',
				allowBlank: true,
				inputType: 'file',				
				invalidText: 'Invalid file extension',
				validator: function(value){
					if(value.search('.csv') == -1 && value.search('.xls') == -1 && value.search('.arff') == -1 && value.search('.sql') == -1 && value.search('.zip') == -1){
						return false;
					}else{
						return true;
					}	
				}
			})			
		);
		upForm.addButton({
			text: 'Upload',
			handler: function(){
				submitForm();
			}			
		});
		upForm.render('$this->id_form');
		
		Ext.get('fileUpload').on('change',function(){
			Ext.get('fileUpload').validate();
		});
		function submitForm(){
			if (upForm.isValid()) {
				layoutIsOpen = false;
				$this->dialogName.hide();
				$this->dialogName.destroy();				
				Ext.MessageBox.wait('Uploading File', 'Please wait');
				upForm.submit({ 
					success:function(form, action){
						checkMessage(action.result.msg.files);
						Ext.MessageBox.hide();
					},								
					failure: function(form, action) {						
						Ext.MessageBox.hide();
					}
				});
			}	
		}
		function checkMessage(data){
			if(data[0].fileStatus == 0){
				xajax_cargar(data[0].fileName,0);
			}else{
				xajax_open(data[0].fileStatus, data[0].fileName,'$id');
			}		
		}
		";
		return $this->upload_form;
	}

	public function getLoginForm($type){
		$loginForm ="
//		Ext.QuickTips.init();
		// turn on validation errors beside the field globally
	//	Ext.form.Field.prototype.msgTarget = 'side';
		logForm = new Ext.form.Form({
				labelAlign: 'right',				
				name: 'loginForm'				
		});
		logForm.add(
			new Ext.form.TextField({
				fieldLabel: '<b>User</b>',				
				name: 'loguser',
				id: 'loguser',
				allowBlank: true,
				invalidText: 'this field is required'
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Password</b>',
				name: 'clauser',
				id: 'clauser',
				allowBlank: true,
				inputType: 'password',
				invalidText: 'this field is required'
			})
		);
		logForm.addButton({
			text: 'Login',
			handler: function(){
				if(logForm.isValid()){					
					xajax_logueo('$type',logForm.getValues(true));
				}
			}			
		});
		logForm.render('$this->id_form');		
		";
		return $loginForm;
	}
	/**
	 * Return js string with all the boxes needed and the render procedure for the form
	 * 
	 *
	 *@param string contains the function to execute if the user press apply button
	 * 
	 *@return js string, the function to execute always return one parameter more, the values of the form
	 *	 
	 */
	public function setCancelFunc($func){
		$this->cancelFunc = $func;
	}
	public function getForm($execFunc,$label_width = '100'){
		$this->dlg_form = "
		var alg_Form = new Ext.form.Form({
		labelWidth: $label_width
		});
		";
		$this->dlg_form .= $this->boxes;
		
		$execFunc = substr($execFunc,0,strlen($execFunc)-1);
		$execFunc .= ",alg_Form.getValues(true));";

		$this->dlg_form .= "
		if(CleanMatch2 == 'clean'){
			alg_Form.addButton({
				text: 'Cancel',
				handler: function(){
					layoutIsOpen = false;
					$this->dialogName.hide();
					$this->dialogName.destroy();
					$this->cancelFunc
				}
			});
		}
		if(CleanMatch == 'clean'){
			apply = alg_Form.addButton({
				text: 'Apply',
				id: 'apply',
				disabled: true,
				handler: function(){
					if(alg_Form.isValid()){
						layoutIsOpen = false;
						$this->dialogName.hide();						
						$this->dialogName.destroy();
						Ext.MessageBox.wait('Processing Data', 'Please Wait');
						$execFunc
					}
				}
			});		
		}else if(CleanMatch == 'match2'){
			alg_Form.addButton({
				text: '<< Back',
				id: 'goBack',
				disabled: false,
				handler: function(){
					CleanMatch = 'match';
					xajax_matchInit();
				}
			});
			alg_Form.addButton({
				text: 'Ready',
				id: 'ready',
				disabled: false,
				handler: function(){
					if(alg_Form.isValid()){
						$execFunc
					}
				}
			});
		}else if(CleanMatch == 'match'){			
			apply = alg_Form.addButton({
				text: 'Next >>',
				id: 'apply',
				disabled: true,
				handler: function(){					
					if(alg_Form.isValid()){
						$execFunc
					}
				}
			});
		}else if(CleanMatch == 'union'){
			alg_Form.addButton({
				text: '<< Back',
				id: 'goBack',
				disabled: false,
				handler: function(){
					CleanMatch = 'match';
					xajax_StartUnion();
				}
			});
			alg_Form.addButton({
				text: 'Ready',
				id: 'ready',
				disabled: false,
				handler: function(){
					if(alg_Form.isValid()){
						$execFunc
					}
				}
			});			
		}else if(CleanMatch == 'stringmode'){
			/*alg_Form.addButton({
				text: 'Cancel',
				handler: function(){
					layoutIsOpen = false;
					$this->dialogName.hide();
					$this->dialogName.destroy();
				}
			});		*/
		//esto para que la select box se active con un solo item en la izquierda
			CleanMatch = 'clean';
		//
			apply = alg_Form.addButton({
				text: 'Next >>',
				id: 'apply',
				disabled: true,
				handler: function(){
					if(alg_Form.isValid()){						
						$execFunc
					}
				}
			});
		}
		alg_Form.render('$this->id_form');
		$this->listeners;	
		if(SBItemStat == 0){
			apply.enable();
		}
		$this->comboEvent;
		";
		$this->boxes = '';
		return $this->dlg_form;
	}
	
public function getFormRule($execFunc,$id){
		$this->dlg_form = "
		alg_Form = new Ext.form.Form({
		labelWidth: 100
		});
		";
		$this->dlg_form .= $this->boxes;
		
		$execFunc = substr($execFunc,0,strlen($execFunc)-1);
		$execFunc .= ",alg_Form.getValues(true));";

		$this->dlg_form .= "apply = alg_Form.addButton({
			text: 'Apply',
			id: 'apply',
			disabled: true,
			handler: function(){
				if(alg_Form.isValid()){					
					Ext.MessageBox.wait('Processing Data', 'Please wait');
					$execFunc
				}
			}
		});
		alg_Form.addButton({
			text: 'Cancel',
			handler: function(){
				$this->dialogName.hide();
				$this->dialogName.destroy();
			}
		});
		alg_Form.render('$this->id_form');		
		alg_Form.items.get('$id').on('focus',function(){document.getElementById('msgDiv').innerHTML = '&nbsp;';});
		if(SBItemStat == 0){
			apply.enable();
		}
		";
		$this->boxes = '';
		return $this->dlg_form;
	}	
	
	/**
	 * Return js string with the dialog box
	 * 
	 *@return js string, the dialog box
	 *	 
	 */
	
	public function getJS(){
		return $this->js_dlg;			
	}
	
	public function setFormWidthGen($width){
		$this->formWidth = $width;
	}
	/**
	 * Return html string with the html structure to create the dialog and the form
	 * 
	 *
	 *@param string contains the title for the dialog
	 * 
	 *@return html string, use with xajax --> $xajax->assign('target','innerHTML',this)
	 *	 
	 */
	
	public function getFormStruct($title,$msg){
		$this->alg_title = $title;
		ob_start();
		?>	
		<div class="x-dlg-hd" ><?php echo $title;?></div>	
		<div class="x-dlg-bd" <?php if($this->formWidth != 0){ echo "style='width:$this->formWidth;'"; }?>  >
			<div id="<?php echo $this->id_cont;?>">
				<div class="x-dlg-tab">
					<div class="inner-tab">
					<div class="x-AlgorithmForm"><?php echo $msg; ?></div>
					<div>
						<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
							<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc"> 							
								<div id="<?php echo $this->id_form;?>"></div>
								<div id="<?php echo $this->id_errormsg;?>" style="color:red;">&nbsp;
								</div>							
							</div></div></div>
							<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
						</div>
					</div>
				</div>
			</div>
			<div id="<?php echo $this->id_help;?>">
			
			</div>
		</div>
		<?php
		return ob_get_clean();
	}
	
	public function getFormStructTwo($title,$msg){
		$this->alg_title = $title;
		ob_start();
		?>	
		<div class="x-dlg-hd" ><?php echo $title;?></div>	
		<div class="x-dlg-bd" <?php if($this->formWidth != 0){ echo "style='width:$this->formWidth;'"; }?>  >
			<div id="<?php echo $this->id_cont;?>">
				<div class="x-dlg-tab">
					<div class="inner-tab">
					<div class="x-AlgorithmForm"><?php echo $msg; ?></div>
					<div>
						<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
							<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc">      
								<table border="0">
								<tr>
									<td width="50%">
										<div id="<?php echo $this->id_form;?>"></div>
										<div id="<?php echo $this->id_errormsg;?>" style="color:red;">&nbsp;
										</div>
									</td>
									<td valign="top" align="center">
										<br>
										<div id="right_div"  style="width:300px;height:380px; overflow:auto;" ></div>
									</td>
								</tr>
								</table>
							</div></div></div>
							<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
						</div>
					</div>
				</div>
			</div>
			<div id="<?php echo $this->id_help;?>">
			
			</div>
		</div>
		<?php
		return ob_get_clean();
	}	
	
	public function getHtmlHelp($Description, $Example){
		$HTMLhelp = $this->setHtmlHelp($Description,$Example);
		return  $HTMLhelp;		
	}
	
	private function setHtmlHelp($Description, $Example){
		$xy = explode(",",$this->contentSize);
		/*
		$h_c_width = $xy[0] - 10;
		$h_c_height = $xy[1] - 30;
		*/
		$h_c_width = "100%";
		$h_c_height = "100%";

		ob_start();
//#CCCC99		
		?>
		<table width="<?php echo $h_c_width; ?>px;" height="<?php echo $h_c_height; ?>px" bgcolor="#E6E6CC">
		<tr>
			<td class="help-heads">
				Description
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->alg_title . " : " . $Description;  ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Parameters
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $this->param_desc; ?>
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Example
			</td>
		</tr>
		<tr>
			<td class="help-content">
				<?php echo $Example;  ?>
			</td>
		</tr>
		</table>		
		
		<?php
		return ob_get_clean();
	}
	
	public function setDescription($desc){
		$this->param_desc .= $desc;
	}
}
?>