<?php
/**
 * 
 * @package userform
 */
class userForm{
	private $formWidth;
	private $id_form;
	private $id_errormsg;
	private $invalidUsers;

	/**
	 * Create a new dialog box for the form
	 * 
	 *
	 *@param string contains the Content Size values --> 'width,height'
	 *@param string the position of the dialog box	 --> 'x,y'
	 */
	public function __construct($invalidUsers,$id_form = 'disc_div'){
		$this->id_form = $id_form;
		$this->id_errormsg = $id_errormsg;		
		$this->formWidth = 0;
		$this->invalidUsers = $invalidUsers;
	}
	
	public  function addUserForm(){
		$form = "
		Ext.QuickTips.init();
	    // turn on validation errors beside the field globally
    	Ext.form.Field.prototype.msgTarget = 'side';
		var addForm = new Ext.form.Form({
				labelAlign: 'right',
				labelWidth: 130,
				name: 'addForm'
		});
		addForm.add(
			new Ext.form.TextField({
				fieldLabel: '<b>First Name</b>',				
				name: 'fname',
				id: 'fname',
				allowBlank: false,
				maxLength : 30
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Last Name</b>',				
				name: 'lname',
				id: 'lname',
				allowBlank: false,
				maxLength : 30
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>User Name</b>',				
				name: 'login',
				id: 'login',
				maxLength : 15,
				allowBlank: false,				
				regex: /^([A-Za-z]+)[A-Za-z\\d]{5,15}$/,
				regexText: 'Invalid user name, must begin with character and between 6 and 15 characters',
				invalidText: 'This user name already exists, please type a new user name',
				validator: function(value){
					var txt = '$this->invalidUsers';
					txt = txt.split('|s|s|s');
					var ban = 1;
					for(var i=0; i<txt.length; i++){
						if(value.toLowerCase() == txt[i]){							
							ban = 0;
							break;
						}else{
							ban = 1;
						}
					}
					if(ban == 0){
						return false;
					}else{
						return true;
					}
				}
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Password</b>',				
				name: 'pass1',
				id: 'pass1',
				inputType: 'password',
				allowBlank: false,
				invalidText: 'This field is required',
				maxLength : 15
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Re-type Password</b>',				
				name: 'pass2',
				id: 'pass2',
				inputType: 'password',
				allowBlank: false,
				maxLength : 15,
				invalidText: 'The password fields must be equals',
				validationEvent : 'blur',
				validator: function(value){
					var txt = addForm.findField('pass1').getValue();
					if(value == txt){
						return true;
					}else{
						return false;
					}
				}
			})
		);
		addForm.addButton({
			text: 'Create Account',
			handler: function(){
				if(addForm.isValid()){				
					xajax_createAccount(addForm.getValues(true));
				}
			}			
		});
		addForm.render('$this->id_form');
		";
		return $form;
	}

	public  function modUserForm($fname,$lname,$login,$logged){
		$form = "
		//Ext.QuickTips.init();
	    // turn on validation errors beside the field globally
    	Ext.form.Field.prototype.msgTarget = 'side';
		var addForm = new Ext.form.Form({
				labelAlign: 'right',
				labelWidth: 130,
				name: 'addForm'
		});
		addForm.add(
			new Ext.form.TextField({
				fieldLabel: '<b>User Name</b>',				
				name: 'login',
				id: 'login',
				readOnly: true,
				value: '$login',
				fieldClass: 'onlyread'
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>First Name</b>',				
				name: 'fname',
				id: 'fname',
				allowBlank: false,
				value: '$fname',
				maxLength : 30
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Last Name</b>',				
				name: 'lname',
				id: 'lname',
				allowBlank: false,
				value: '$lname',
				maxLength : 30
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Password</b>',				
				name: 'pass1',
				id: 'pass1',
				inputType: 'password',
				allowBlank: false,
				invalidText: 'This field is required',
				maxLength : 15
			}),
			new Ext.form.TextField({
				fieldLabel: '<b>Re-type Password</b>',				
				name: 'pass2',
				id: 'pass2',
				inputType: 'password',
				allowBlank: false,
				maxLength : 15,
				invalidText: 'The password fields must be equals',
				validationEvent : 'blur',
				validator: function(value){
					var txt = addForm.findField('pass1').getValue();
					if(value == txt){
						return true;
					}else{
						return false;
					}
				}
			}),
			new Ext.form.ComboBox({
				fieldLabel: '<b>Logged</b>',
				name: 'logged',
				store: new Ext.data.SimpleStore({
					fields: ['id', 'state'],
					data : [['1','Yes'],['2','No']]
				}),
				displayField:'state',
				typeAhead: true,
				mode: 'local',
				triggerAction: 'all',
				value: '$logged',
				selectOnFocus:true,
				width:60
			})
		);
		addForm.addButton({
			text: 'Modify Account',
			handler: function(){
				if(addForm.isValid()){
					xajax_modifyAccount(addForm.getValues(true));
				}
			}			
		});
		addForm.render('$this->id_form');
		";
		return $form;
	}
	
	public function setFormWidthGen($width){
		$this->formWidth = $width;
	}
	/**
	 * Return html string with the html structure to create the dialog and the form
	 * 
	 *
	 *@param string contains the title for the dialog
	 * 
	 *@return html string, use with xajax --> $xajax->assign('target','innerHTML',this)
	 *	 
	 */
	public function getFormStruct($title,$msg){		
		$this->lg_title = $title;
		ob_start();
		?>	<br /><center>
				<div class="x-dlg-tab" style="width:350px;">
					<div class="inner-tab">
						<div class="x-AlgorithmForm"><?php echo $msg; ?></div>
						<br />
						<div>
							<div class="x-box-tl"><div class="x-box-tr"><div class="x-box-tc"></div></div></div>
								<div class="x-box-ml"><div class="x-box-mr"><div class="x-box-mc"> 							
									<div id="<?php echo $this->id_form;?>"></div>
									<div id="<?php echo $this->id_errormsg;?>" style="color:red;">&nbsp;
									</div>							
								</div></div></div>
							<div class="x-box-bl"><div class="x-box-br"><div class="x-box-bc"></div></div></div>
						</div>
					</div>
				</div>
			</center>
		<?php
		return ob_get_clean();
	}
}
?>